Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
curl --compressed -H 'Accept: application/json' 'https://<api_hostname>/<endpoint>'Accurately value your digital assets to meet fair value standards and regulatory requirements.
X-Api-Key: <client-api-key>curl --compressed -H 'Accept: application/json' 'https://reference-data-api.kaiko.io/v1/blockchains'{
"result":"success",
"count": 10,
"data":
[
{"id":1,"name":"ethereum","is_evm":true},
{"id":2,"name":"bsc","is_evm":true},
{"id":3,"name":"polygon","is_evm":true},
{"id":4,"name":"arbitrum","is_evm":true},
{"id":5,"name":"avalanche","is_evm":true},
/* ... */
]
}https://reference-data-api.kaiko.io/v1/blockchainscurl --compressed -H 'Accept: application/json' 'https://reference-data-api.kaiko.io/v1/assets'{
"result": "success",
"data": [
{
"code": "btc",
"name": "Bitcoin",
"asset_class": "cryptocurrency",
"asset_classes": [
"cryptocurrency"
]
},
{
"code": "bch",
"name": "Bitcoin Cash",
"asset_class": "cryptohttps://reference-data-api.kaiko.io/v1/assetscurl --compressed -H 'Accept: application/json' 'https://reference-data-api.kaiko.io/v1/pools-protocols'{
"result": "success",
https://reference-data-api.kaiko.io/v1/pools-protocolsimport http.client
import json
conn = http.client.HTTPSConnection("us.market-api.kaiko.io")
endpoint = "/v2/data/trades.v1/spot_exchange_rate/btc/usd"
params = "?interval=1h&start_time=2024-09-01T00:00:00.000Z&end_time=2024-09-10T00:00:00.000Z"
headers = {
"X-Api-Key": "XXX",
"Accept": "application/json"
}
all_trades = []
next_url = endpoint + params
while next_url:
conn.request("GET", next_url, headers=headers)
response = conn.getresponse()
data = json.loads(response.read().decode("utf-8"))
all_trades.extend(data.get("data", []))
print(f"Fetched {len(data.get('data', []))} datapoints. Total: {len(all_trades)}")
next_url = data.get("next_url", "").replace("https://us.market-api.kaiko.io", "")
if not next_url:
break
conn.close()
print(f" datapoints fetched: {(all_trades)}")curl --compressed -H 'Accept: application/json' 'https://reference-data-api.kaiko.io/v1/exchanges'import requests
import pandas as pd
trade_url = "https://us.market-api.kaiko.io/v3/data/trades.v1/exchanges/usp3/spot/usdc-weth/trades?start_time=2022-11-01T00:00:00.000Z&end_time=2022-12-01T00:00:00.000Z"
headers = {"X-Api-Key": "XXX","Accept": "application/json"}
output = requests.get(trade_url, headers = headers).json()
df = pd.DataFrame(output["data"])
while "next_url" in output:
output = requests.get(output["next_url"], headers = headers).json()
df_to_add = pd.DataFrame(output["data"])
print(df_to_add)
df= pd.concat([df, df_to_add])
print(df){
"result": "success",
"data": [
{
"code": "bfly",
"name": "bitFlyer",
"kaiko_legacy_slug": "bl"
},
{
"code": "bfnx",
"name": "Bitfinex",
"kaiko_legacy_slug": "bf"
}
/* ... */
]
}curl --compressed -H 'Accept: application/json' 'https://reference-data-api.kaiko.io/v1/pools'{
"result": "success",
"count": 1537,
"data":
[
{
"blockchain": "bsc",
"address": "0x0004222c2075e9a1291e41f1ca4c8d32141db501",
"name": "MBOX-WBNB-0.003",
"protocol": "pks3",
"type": "liquidity_pool",
"fee": "0.0025",
"tokens":
[
{
"blockchain": "bsc",
"address": "0x3203c9e46ca618c8c1ce5dc67e7e9d75f5da2377",
"symbol": "mbox",
"decimals": "18"
},
{
"blockchain": "bsc",
"address": "0xbb4cdb9cbd36b01bd1cbaebf2de08d9173bc095c",
"symbol": "wbnb",
"decimals": "18"
}
],
"tickSpacing": "50"
},
/**********/
]
}curl -H 'Accept: application/json' -H 'X-Api-Key: <client-api-key>' \
'https://us.market-api.kaiko.io/v2/data/dlr/statistics?start_date=20250601&end_date=20250630&page_size=1000&sort=asc'import requests
url = "https://us.market-api.kaiko.io/v2/data/dlr/statistics"
headers = {"X-Api-Key": "<client-api-key>", "Accept": "application/json"}
params = {
"start_date": "20250601",
"end_date": "20250630",
"sort": "asc"
}
response = requests.get(url, headers=headers, params=params)
print(response.json())https://<eu|us>.market-api.kaiko.io/v2/data/dlr/statistics{
"time": "2025-06-26T07:45:28.269608752Z",
"timestamp": 1750923928,
"data": [
{
"date": "20250601",
"timestamp": 1704067200000,
"contracts": 1250,
"quantity": 100000000,
"funds": 113000000
},
{
"date": "20250602",
"timestamp": 1704153600000,
"contracts": 1270,
"quantity": 102500000,
"funds": 115000000
}
/* ... */
],
"continuation_token": "mUNJbiuDHsQ3dtNu7FCP1e8ymWhSnGd7fTuKsJWrGzzw5dACxNpMQ6BwicaUqijfj1bB9GtdYKar4c6BUtkQ8CVunEtCtkwPuCNg8HdhvQXtBxEKy",
"next_url": "https://us.market-api.kaiko.io/v2/data/dlr/statistics?continuation_token=mUNJbiuDHsQ3dtNu7FCP1e8ymWhSnGd7fTuKsJWrGzzw5dACxNpMQ6BwicaUqijfj1bB9GtdYKar4c6BUtkQ8CVunEtCtkwPuCNg8HdhvQXtBxEKy"
}{
"query": {},
"time": "2024-05-21T07:04:25.684Z",
"timestamp": 1716275065684,
"data": [
{
"trade_date": "2024-04-30",
"timestamp": 1714489210000,
"product_code": "BTC",
"instrument": "BTCK4",
"description": "Bitcoin Futures",
"fixing_price": 61602.66
},
/* ... */
],
"result": "success"
}{
"query": {},
"time": "2024-05-21T09:44:14.892Z",
"timestamp": 1716284654892,
"data": [
{
"ref_date": "2024-04-26",
"instrument": "AAVEUSD_RR",
"price": 90.7542
},
{
"ref_date": "2024-04-26",
"instrument": "ADAUSD_RR",
"price": 0.470587
},
/* ... */
],
"result": "success"
}https://us.market-api.kaiko.io/v2/data/fixing.v1/xcmecurl --compressed -H 'Accept: application/json' -H 'X-Api-Key: <client-api-key>' \
'https://us.market-api.kaiko.io/v2/data/fixing.v1/xcme'https://us.market-api.kaiko.io/v2/data/cfbenchmark.v1/cfbenchmarks/xcmecurl --compressed -H 'Accept: application/json' -H 'X-Api-Key: <client-api-key>' \
'https://us.market-api.kaiko.io/v2/data/cfbenchmark.v1/cfbenchmarks/xcme'https://us.market-api.kaiko.io/v2/data/trades.v1/principal_market_valuecurl --compressed -H 'Accept: application/json' -H 'X-Api-Key: <client-api-key>' \
'https://us.market-api.kaiko.io/v2/data/trades.v1/principal_market_value?end_time=2025-09-09T15:00:00.000Z&asset=btc'##### 1. Import dependencies #####
import requests
import pandas as pd
##### 2. Choose the value of the query's parameters #####
# ---- Required parameters ---- #
asset = "btc"
# ---- Optional parameters ---- #
end_time = "2025-09-09T15:00:00.000Z"
# ---- API key configuration ---- #
api_key = "YOUR_API_KEY"
##### 3. Get the data #####
# ---- Function to run an API call ---- #
# Get the data in a dataframe --------- #
def get_kaiko_data(api_key: str, asset: str, end_time: str = None):
headers = {'Accept': 'application/json', 'X-Api-Key': api_key}
url = f'https://us.market-api.kaiko.io/v2/data/trades.v1/principal_market_value'
params = {
"asset": asset,
"end_time": end_time
}
try:
res = requests.get(url, headers=headers, params=params)
res.raise_for_status()
data = res.json()
if 'data' not in data:
print("No data returned.")
return pd.DataFrame()
df = pd.DataFrame(data['data'])
# Handle pagination with continuation token
while 'next_url' in data:
next_url = data['next_url']
if next_url is None:
break
res = requests.get(next_url, headers=headers)
res.raise_for_status()
data = res.json()
if 'data' in data:
df = pd.concat([df, pd.DataFrame(data['data'])], ignore_index=True)
return df
except requests.exceptions.RequestException as e:
print(f"API request error: {e}")
return pd.DataFrame()
# ---- Get the data ---- #
df = get_kaiko_data(api_key=api_key, asset=asset, end_time=end_time)
print(df){
"query": {
"end_time": "2025-09-09T15:00:00Z",
"asset": "btc",
"data_version": "v1",
"commodity": "principal_market_value",
"request_time": "2025-09-15T13:00:08.391Z",
"end_timestamp": 1757430000000
},
"time": "2025-09-15T13:00:08.494Z",
"timestamp": 1757941208494,
"data": [
{
"timestamp": 1757430000000,
"last_trade_timestamp": 1757429999945,
"price": 111764,
"principal_market_name": "CRCO",
"principal_market_code": "crco",
"adtv_2w": 8135.835284285715,
"total_adtv_2w": 16893.05731083857
}
],
"result": "success",
"access": {
"access_range": {
"start_timestamp": 1454284800000,
"end_timestamp": 1877896800000
},
"data_range": {
"start_timestamp": 1454281200000,
"end_timestamp": 1877896800000
}
}
}curl --compressed -H 'Accept: application/json' -H 'X-Api-Key: <client-api-key>' \
'https://us.market-api.kaiko.io/v2/data/analytics.v2/oanda_fx_rates?base=eur&page_size=2&sort=desc&interval=1d"e=jpy'##### 1. Import dependencies #####
import requests
import pandas as pd
##### 2. Choose the value of the query's parameters #####
# ---- Required parameters ---- #
quote = "usd"
base = "jpy"
# ---- Optional parameters ---- #
interval = "1h"
sort = "desc"
page_size = 100
start_time= "2025-01-01T00:00:00.000Z"
end_time= "2025-01-31T00:00:00.000Z"
# ---- API key configuration ---- #
api_key = "YOUR_API_KEY"
##### 3. Get the data #####
# ---- Function to run an API call ---- #
# Get the data in a dataframe --------- #
def get_kaiko_data(api_key: str, quote: str, base: str, start_time: str, end_time: str, interval: str, sort: str, page_size: int):
headers = {'Accept': 'application/json', 'X-Api-Key': api_key}
url = f'https://us.market-api.kaiko.io/v2/data/analytics.v2/oanda_fx_rates'
params = {
"start_time": start_time,
"end_time": end_time,
"sort": sort,
"page_size": page_size,
"interval": interval,
"quote": quote,
"base": base
}
try:
res = requests.get(url, headers=headers, params=params)
res.raise_for_status()
data = res.json()
if 'data' not in data:
print("No data returned.")
return pd.DataFrame()
df = pd.DataFrame(data['data'])
# Handle pagination with continuation token
while 'next_url' in data:
next_url = data['next_url']
if next_url is None:
break
res = requests.get(next_url, headers=headers)
res.raise_for_status()
data = res.json()
if 'data' in data:
df = pd.concat([df, pd.DataFrame(data['data'])], ignore_index=True)
return df
except requests.exceptions.RequestException as e:
print(f"API request error: {e}")
return pd.DataFrame()
# ---- Get the data ---- #
df = get_kaiko_data(api_key=api_key, quote=quote, base=base, interval=interval, start_time=start_time, end_time=end_time, sort=sort, page_size=page_size)
print (df){
"query": {
"base": "eur",
"quote": "jpy",
"interval": "1d",
"page_size": "2",
"sort": "desc",
"start_time": "null",
"end_time": "2022-08-31T08:38:25.883Z"
},
"time": "2022-08-31T08:38:25.905Z",
"timestamp": 1661935105,
"data": [
{
"timestamp": 1660780800000,
"fx_rate": "137.38630485436903"
},
{
"timestamp": 1660694400000,
"fx_rate": "137.15155641205303"
}
],
"continuation_token": "4tvMKJPYA6ESWsE7s87P2ujFvr6XRNvegzst2eg1EpdyQEPKWpuNic5XPGrhz47RzbbqC598E3XusLo34Hivgw4sYrrvdmYxL7WQVtebjtYVMUPPd97vqo2VjL22A6cTSNojTQsvHh8T6MPRjuJAMfx5LWyVZQWYyzLrSE",
"next_url": "https://us.market-api.kaiko.io/v2/data/analytics.v2/oanda_fx_rates?continuation_token=4tvMKJPYA6ESWsE7s87P2ujFvr6XRNvegzst2eg1EpdyQEPKWpuNic5XPGrhz47RzbbqC598E3XusLo34Hivgw4sYrrvdmYxL7WQVtebjtYVMUPPd97vqo2VjL22A6cTSNojTQsvHh8T6MPRjuJAMfx5LWyVZQWYyzLrSE"
}https://us.market-api.kaiko.io/v2/data/analytics.{data_version}/oanda_fx_rates{
"datetime": "2025-01-08T10:48:58.002432007Z",
"base": "wsteth",
"lst_quote": "weth",
"aggregated_price_usd": "3985.5509347142515",
"aggregated_price_lst": "1.1892311869094472",
"last_known_blocks": [
{
"blockchain": "ethereum",
"block_number": 21579259
}
],
"pool_data": [
{
"pool_address": "0x93d199263632a4ef4bb438f1feb99e57b4b5f0bd",
"blockchain": "ethereum",
"exchange": "blc2",
"quote": "weth",
"state_price": "1.1892290818833757",
"rate_usd": 3351.367655495001,
"trading_volume_weight": "0.642086707107293",
"market_depth_weight": "0.07335226235574528",
"market_depth_m1_quote": "19.395711139793057",
"market_depth_m1_usd": "65002.15896922653",
"market_depth_p1_base": "108.00101402959565",
"market_depth_p1_usd": "430442.780499229",
"last_block_volume": "0",
"last_aggregated_volume": "28000.703235419944"
},
{
"pool_address": "0x109830a1aaad605bbf02a9dfa7b0b92ec2fb7daa",
"blockchain": "ethereum",
"exchange": "usp3",
"quote": "weth",
"state_price": "1.1892322697310238",
"rate_usd": 3351.367655495001,
"trading_volume_weight": "0.7417266504989011",
"market_depth_weight": "1.0729150777662464",
"market_depth_m1_quote": "2603.753585841387",
"market_depth_m1_usd": "8726135.550467951",
"market_depth_p1_base": "952.8608347165278",
"market_depth_p1_usd": "3797678.8483253857",
"last_block_volume": "0",
"last_aggregated_volume": "34687.298752135"
},
]
}curl --compressed -H 'Accept: application/json' -H 'X-Api-Key: <client-api-key>' \
'https://us.market-api.kaiko.io/v2/data/supply.v2/aggregated/btc?start_time=2025-10-20T00:00:00.000Z&end_time=2025-10-21T00:00:00.000Z&page_size=100&interval=1d'import http.client
import json
# Enter your Kaiko API Key
api_key = "KAIKO_API_KEY"
api_host = "us.market-api.kaiko.io"
api_base_endpoint = "/v2/data/supply.v2/aggregated/btc"
# Start of mandatory parameter configuration
mandatory_params = {
'start_time':'2025-10-20T00:00:00.000Z',
'end_time':'2025-10-21T00:00:00.000Z',
'page_size':100,
'interval':'1d'
}
# End of mandatory parameter configuration
# Start of optional parameter configuration
optional_params = {
}
# End of optional parameter configuration
conn = http.client.HTTPSConnection(api_host)
headers = {
"X-Api-Key": api_key,
"Accept": "application/json"
}
all_params = {**mandatory_params, **optional_params}
url_params = []
for param, value in all_params.items():
url_params.append(f"{param}={value}")
url_params = '&'.join(url_params)
endpoint_with_params = f"{api_base_endpoint}?{url_params}"
# Pagination for next pages
all_data = []
next_url = endpoint_with_params
while next_url:
conn.request("GET", next_url, headers=headers)
response = conn.getresponse()
data = json.loads(response.read().decode("utf-8"))
all_data.extend(data.get("data", []))
print(f"Fetched {len(data.get('data', []))} datapoints. Total: {len(all_data)}")
next_url = data.get("next_url", "").replace("https://us.market-api.kaiko.io", "")
if not next_url:
break
conn.close()
print(f" datapoints fetched: {(all_data)}")https://us.market-api.kaiko.io/v2/data/supply.v2/aggregated/{asset}{
"query":
{
"start_time": "2025-10-20T00:00:00.000Z",
"end_time": "2025-10-21T00:00:00.000Z",
"page_size": 100,
"asset": "btc",
"interval": "1d",
"sort": "asc",
"request_time": "2025-11-12T14:18:27.226Z",
"start_timestamp": 1760918400000,
"end_timestamp": 1761004800000
},
"time": "2025-11-12T14:18:27.253Z",
"timestamp": 1762957107253,
"data":
[
{
"timestamp": 1760918400,
"asset": "btc",
"circulating_supply": 19937318.75,
"market_cap": 2209402368348.39,
"total_supply": 19937318.75
}
/** Results **/
],
"result": "success",
"continuation_token": "xxx",
"next_url": "https://us.market-api.kaiko.io/v2/data/supply.v2/aggregated/btc?continuation_token=xxx",
"access":
{
"access_range":
{
"start_timestamp": 1073001600000,
"end_timestamp": "None"
},
"data_range":
{
"start_timestamp": "None",
"end_timestamp": "None"
}
}
}https://<eu|us>.market-api.kaiko.io/v2/data/trades.v1/exchanges/{exchange}/{instrument_class}/{instrument}/aggregations/vwaphttps://us.market-api.kaiko.io/v2/data/supply.v2/topcurl --compressed -H 'Accept: application/json' -H 'X-Api-Key: <client-api-key>' \
'https://us.market-api.kaiko.io/v2/data/supply.v2/top?datetime=2026-01-01T00:00:00.000Z&count=10&interval=1d'import http.client
import json
# Enter your Kaiko API Key
api_key = "KAIKO_API_KEY"
api_host = "us.market-api.kaiko.io"
api_base_endpoint = "/v2/data/supply.v2/top"
# Start of mandatory parameter configuration
mandatory_params = {
'datetime':'2026-01-01T00:00:00.000Z',
'count':10,
'interval':'1d'
}
# End of mandatory parameter configuration
# Start of optional parameter configuration
optional_params = {
}
# End of optional parameter configuration
conn = http.client.HTTPSConnection(api_host)
headers = {
"X-Api-Key": api_key,
"Accept": "application/json"
}
all_params = {**mandatory_params, **optional_params}
url_params = []
for param, value in all_params.items():
url_params.append(f"{param}={value}")
url_params = '&'.join(url_params)
endpoint_with_params = f"{api_base_endpoint}?{url_params}"
# Pagination for next pages
all_data = []
next_url = endpoint_with_params
while next_url:
conn.request("GET", next_url, headers=headers)
response = conn.getresponse()
data = json.loads(response.read().decode("utf-8"))
all_data.extend(data.get("data", []))
print(f"Fetched {len(data.get('data', []))} datapoints. Total: {len(all_data)}")
next_url = data.get("next_url", "").replace("https://us.market-api.kaiko.io", "")
if not next_url:
break
conn.close()
print(f" datapoints fetched: {(all_data)}"){
"query":
{
"datetime": "2026-01-01T00:00:00.000Z",
"count": 10,
"interval": "1d"
},
"time": "2026-02-10T13:10:35.136Z",
"timestamp": 1770729035136,
"data":
[
{
"datetime": 1767225600,
"asset": "btc",
"rank": 1,
"total_supply": 19969814.0625,
"circulating_supply": 19969814.0625,
"market_cap": 1754840038141.7961
},
{
"datetime": 1767225600,
"asset": "eth",
"rank": 2,
"total_supply": 120694917.35776222,
"circulating_supply": 120694917.35776222,
"market_cap": 359309601750.3176
},
{
"datetime": 1767225600,
"asset": "usdt",
"rank": 3,
"total_supply": 191200669545.90054,
"circulating_supply": 186408947507.7797,
"market_cap": 186164285382.73282
},
/** Results **/
],
"result": "success"
}curl --compressed -H 'Accept: application/json' -H 'X-Api-Key: <client-api-key>' \
'https://us.market-api.kaiko.io/v2/data/trades.v1/exchanges/cbse/spot/btc-usd/aggregations/vwap'##### 1. Import dependencies #####
import requests
import pandas as pd
##### 2. Choose the value of the query's parameters #####
# ---- Required parameters ---- #
exchange = "cbse"
instrument_class = "spot"
pair = "btc-usd" #called "instrument" in the documentation
# ---- Optional parameters ---- #
interval = "1d"
sort = "desc"
page_size = 100
start_time= "2023-01-01T00:00:00Z"
end_time= "2023-12-31T23:59:59Z"
# ---- API key configuration ---- #
api_key = "YOUR_API_KEY"
##### 3. Get the data #####
# ---- Function to run an API call ---- #
# Get the data in a dataframe --------- #
def get_kaiko_data(api_key: str, exchange: str, pair: str, instrument_class: str, start_time: str, end_time: str, interval: str, sort: str, page_size: int):
headers = {'Accept': 'application/json', 'X-Api-Key': api_key}
url = f'https://us.market-api.kaiko.io/v2/data/trades.v1/exchanges/{exchange}/{instrument_class}/{pair}/aggregations/vwap'
params = {
"start_time": start_time,
"end_time": end_time,
"sort": sort,
"page_size": page_size,
"interval": interval
}
try:
res = requests.get(url, headers=headers, params=params)
res.raise_for_status()
data = res.json()
if 'data' not in data:
print("No data returned.")
return pd.DataFrame()
df = pd.DataFrame(data['data'])
# Handle pagination with continuation token
while 'next_url' in data:
next_url = data['next_url']
if next_url is None:
break
res = requests.get(next_url, headers=headers)
res.raise_for_status()
data = res.json()
if 'data' in data:
df = pd.concat([df, pd.DataFrame(data['data'])], ignore_index=True)
return df
except requests.exceptions.RequestException as e:
print(f"API request error: {e}")
return pd.DataFrame()
# ---- Get the data ---- #
df = get_kaiko_data(api_key=api_key, exchange=exchange, pair=pair, instrument_class=instrument_class, start_time=start_time, end_time=end_time ,interval=interval, sort=sort, page_size=page_size){
"query": {
"page_size": 100,
"exchange": "cbse",
"instrument_class": "spot",
"instrument": "btc-usd",
"interval": "1d",
"sort": "desc",
"aggregation": "vwap",
"data_version": "v1",
"commodity": "trades",
"request_time": "2020-11-12T16:52:36.988Z"
},
"time": "2020-11-12T16:52:37.114Z",
"timestamp": 1605199957114,
"data": [
{
"timestamp": 1605139200000,
"price": "15879.385939106618"
},
{
"timestamp": 1605052800000,
"price": "15664.643871798791"
},
/* ... */
],
"result": "success",
"continuation_token": "55qoNvASfrVdCIjrF8Ygw6TVJ4yamzUyeL9QXAmvWZZur3iaKoPcVBW1V4unNJi2zMjojbsYr9Pgt9XFCUpnAiuBiECm8X4cedvYc9t2WxHXnHKjgAp2wRAeV8ZPUSj8WNgpWTCBVymGaQZPj3oMDZwVeCPyuTLFdVPfTXVjZA94BtHeBmghoPv92JtWxN3yRvCkrw79hJBu",
"next_url": "https://<eu|us>.market-api.kaiko.io/v2/data/trades.v1/exchanges/cbse/spot/btc-usd/aggregations/vwap?continuation_token=55qoNvASfrVdCIjrF8Ygw6TVJ4yamzUyeL9QXAmvWZZur3iaKoPcVBW1V4unNJi2zMjojbsYr9Pgt9XFCUpnAiuBiECm8X4cedvYc9t2WxHXnHKjgAp2wRAeV8ZPUSj8WNgpWTCBVymGaQZPj3oMDZwVeCPyuTLFdVPfTXVjZA94BtHeBmghoPv92JtWxN3yRvCkrw79hJBu",
"access": {
"access_range": {
"start_timestamp": 1546300800000,
"end_timestamp": 1577836800000
},
"data_range": {
"start_timestamp": 1417391000000,
"end_timestamp": 1577836800000
}
}
}curl --compressed -H 'Accept: application/json' -H 'X-Api-Key: <client-api-key>' \
'https://us.market-api.kaiko.io/v2/data/staking.v1/protocols/solana?start_date=20261001'import http.client
import json
# Enter your Kaiko API Key
api_key = "KAIKO_API_KEY"
api_host = "us.market-api.kaiko.io"
api_base_endpoint = "/v2/data/staking.v1/protocols/solana"
# Start of mandatory parameter configuration
mandatory_params = {
}
# End of mandatory parameter configuration
# Start of optional parameter configuration
optional_params = {
'start_date':'20251001',
'page_size':100,
'sort':'desc',
'methodology':'epoch_aggregate_v1'
}
# End of optional parameter configuration
conn = http.client.HTTPSConnection(api_host)
headers = {
"X-Api-Key": api_key,
"Accept": "application/json"
}
all_params = {**mandatory_params, **optional_params}
url_params = []
for param, value in all_params.items():
url_params.append(f"{param}={value}")
url_params = '&'.join(url_params)
endpoint_with_params = f"{api_base_endpoint}?{url_params}"
# Pagination for next pages
all_data = []
next_url = endpoint_with_params
while next_url:
conn.request("GET", next_url, headers=headers)
response = conn.getresponse()
data = json.loads(response.read().decode("utf-8"))
all_data.extend(data.get("data", []))
print(f"Fetched {len(data.get('data', []))} datapoints. Total: {len(all_data)}")
next_url = data.get("next_url", "").replace("https://us.market-api.kaiko.io", "")
if not next_url:
break
conn.close()
print(f" datapoints fetched: {(all_data)}"){
"query":
{
"start_date": "20260101",
"end_date": "20260422",
"start_time": "2026-01-01T00:00:00Z",
"end_time": "2026-04-22T00:00:00Z",
"sort": "descending",
"page_size": "10",
"methodology": "epoch_aggregate_v1"
},
"time": "2026-04-22T14:46:38.274392363Z",
"timestamp": 1776869198,
"data":
[
{
"date": "2026-04-21",
"protocol": "solana",
"apr": 4.758636113435191,
"validators": 777,
"methodology": "epoch_aggregate_v1"
},
/** Results **/
],
"continuation_token": "xxx",
"next_url": "https://eu.market-api.kaiko.io/v2/data/staking.v1/protocols/solana?continuation_token=xxx"
}
curl --compressed -H 'Accept: application/json' -H 'X-Api-Key: <client-api-key>' \
'https://us.market-api.kaiko.io/v2/data/tvl?start_date=20251001&protocol=aave'import http.client
import json
# Enter your Kaiko API Key
api_key = "KAIKO_API_KEY"
api_host = "us.market-api.kaiko.io"
api_base_endpoint = "/v2/data/tvl"
# Start of mandatory parameter configuration
mandatory_params = {
}
# End of mandatory parameter configuration
# Start of optional parameter configuration
optional_params = {
'start_date':'20251001',
'page_size':100,
'sort':'desc',
'protocol':'aave'
}
# End of optional parameter configuration
conn = http.client.HTTPSConnection(api_host)
headers = {
"X-Api-Key": api_key,
"Accept": "application/json"
}
all_params = {**mandatory_params, **optional_params}
url_params = []
for param, value in all_params.items():
url_params.append(f"{param}={value}")
url_params = '&'.join(url_params)
endpoint_with_params = f"{api_base_endpoint}?{url_params}"
# Pagination for next pages
all_data = []
next_url = endpoint_with_params
while next_url:
conn.request("GET", next_url, headers=headers)
response = conn.getresponse()
data = json.loads(response.read().decode("utf-8"))
all_data.extend(data.get("data", []))
print(f"Fetched {len(data.get('data', []))} datapoints. Total: {len(all_data)}")
next_url = data.get("next_url", "").replace("https://us.market-api.kaiko.io", "")
if not next_url:
break
conn.close()
print(f" datapoints fetched: {(all_data)}"){
"query":
{
"protocol": "aave",
"start_date": "seconds:1759276800",
"end_date": "seconds:1764028800",
"sort": "desc",
"page_size": "1"
},
"time": "2025-11-25T10:20:15.37953193Z",
"timestamp": 1764066015,
"data":
[
{
"timestamp": 1763856000,
"protocol_name": "Aave",
"protocol_code": "aave",
"tvl": 50404639283.57133
},
/** Results **/
],
"continuation_token": "xxx",
"next_url": "https://eu.market-api.kaiko.io/v2/data/tvl?continuation_token=xxx"
}
https://us.market-api.kaiko.io/v2/data/supply.v2/blockchain-level/{blockchain}/{asset}curl --request GET \
--url 'https://us.market-api.kaiko.io/v2/data/supply.v2/blockchain-level/canton/cbtc?2026-05-13T00:00:00Z&end_time=2026-05-13T23:59:59Z&page_size=10&sort=desc' \
--header 'Accept: application/json' \
--header 'X-Api-Key: KAIKO_API_KEY'import http.client
import json
# Enter your Kaiko API Key
api_key = "KAIKO_API_KEY"
api_host = "us.market-api.kaiko.io"
api_base_endpoint = "/v2/data/supply.v2/blockchain-level/canton/cbtc"
# Start of mandatory parameter configuration
mandatory_params = {
}
# End of mandatory parameter configuration
# Start of optional parameter configuration
optional_params = {
'start_time':'2026-05-13T00:00:00Z',
'end_time':'2026-05-13T23:59:59Z',
'page_size':10,
'sort':'desc'
}
# End of optional parameter configuration
conn = http.client.HTTPSConnection(api_host)
headers = {
"X-Api-Key": api_key,
"Accept": "application/json"
}
all_params = {**mandatory_params, **optional_params}
url_params = []
for param, value in all_params.items():
url_params.append(f"{param}={value}")
url_params = '&'.join(url_params)
endpoint_with_params = f"{api_base_endpoint}?{url_params}"
# Pagination for next pages
all_data = []
next_url = endpoint_with_params
while next_url:
conn.request("GET", next_url, headers=headers)
response = conn.getresponse()
data = json.loads(response.read().decode("utf-8"))
all_data.extend(data.get("data", []))
print(f"Fetched {len(data.get('data', []))} datapoints. Total: {len(all_data)}")
next_url = data.get("next_url", "").replace("https://us.market-api.kaiko.io", "")
if not next_url:
break
conn.close()
print(f" datapoints fetched: {(all_data)}"){
"query": {
"start_time": "2026-05-13T00:00:00.000Z",
"end_time": "2026-05-13T23:59:59.000Z",
"page_size": 10,
"asset": "cbtc",
"blockchain": "canton",
"sort": "desc",
"request_time": "2026-05-13T07:57:55.131Z",
"start_timestamp": 1778630400000,
"end_timestamp": 1778716799000
},
"time": "2026-05-13T07:57:55.136Z",
"timestamp": 1778659075136,
"data": [
{
"timestamp": 1778655600,
"asset": "cbtc",
"blockchain": "canton",
"total_supply": 29.0089104357,
"circulating_supply": null,
"market_cap": null
}
/** Results **/
],
"result": "success",
"access": {
"access_range": {
"start_timestamp": 1578006000000,
"end_timestamp": 1893625200000
},
"data_range": {
"start_timestamp": 1578006000000,
"end_timestamp": 1893625200000
}
}
}curl --compressed -H 'Accept: application/json' -H 'X-Api-Key: <client-api-key>' \
'https://us.market-api.kaiko.io/v2/data/trades.v1/exchanges/cbse/spot/btc-usd/aggregations/ohlcv'##### 1. Import dependencies #####
import requests
import pandas as pd
##### 2. Choose the value of the query's parameters #####
# ---- Required parameters ---- #
exchange = "cbse"
instrument_class = "spot"
pair = "btc-usd" #called "instrument" in the documentation
# ---- Optional parameters ---- #
interval = "1d"
sort = "desc"
page_size = 100
start_time= "2023-01-01T00:00:00Z"
end_time= "2023-12-31T23:59:59Z"
# ---- API key configuration ---- #
api_key = "YOUR_API_KEY"
##### 3. Get the data #####
# ---- Function to run an API call ---- #
# Get the data in a dataframe --------- #
def get_kaiko_data(api_key: str, exchange: str, pair: str, instrument_class: str, start_time: str, end_time: str, interval: str, sort: str, page_size: int):
headers = {'Accept': 'application/json', 'X-Api-Key': api_key}
url = f'https://us.market-api.kaiko.io/v2/data/trades.v1/exchanges/{exchange}/{instrument_class}/{pair}/aggregations/ohlcv'
params = {
"start_time": start_time,
"end_time": end_time,
"sort": sort,
"page_size": page_size,
"interval": interval
}
try:
res = requests.get(url, headers=headers, params=params)
res.raise_for_status()
data = res.json()
if 'data' not in data:
print("No data returned.")
return pd.DataFrame()
df = pd.DataFrame(data['data'])
# Handle pagination with continuation token
while 'next_url' in data:
next_url = data['next_url']
if next_url is None:
break
res = requests.get(next_url, headers=headers)
res.raise_for_status()
data = res.json()
if 'data' in data:
df = pd.concat([df, pd.DataFrame(data['data'])], ignore_index=True)
return df
except requests.exceptions.RequestException as e:
print(f"API request error: {e}")
return pd.DataFrame()
# ---- Get the data ---- #
df = get_kaiko_data(api_key=api_key, exchange=exchange, pair=pair, instrument_class=instrument_class, start_time=start_time, end_time=end_time ,interval=interval, sort=sort, page_size=page_size)https://<eu|us>.market-api.kaiko.io/v2/data/trades.v1/exchanges/{exchange}/{instrument_class}/{instrument}/aggregations/ohlcv{
"query": {
"page_size": 100,
"exchange": "cbse",
"instrument_class": "spot",
"instrument": "btc-usd",
"interval": "1d",
"sort": "desc",
"aggregation": "ohlcv",
"data_version": "v1",
"commodity": "trades",
"request_time": "2020-05-26T17:25:56.221Z"
},
"time": "2020-05-26T17:26:00.160Z",
"timestamp": 1590513960160,
"data": [
{
"timestamp": 1590451200000,
"open": "8900.0",
"high": "9016.99",
"low": "8694.23",
"close": "8811.36",
"volume": "9014.60281966"
},
{
"timestamp": 1590364800000,
"open": "8715.69",
"high": "8977.0",
"low": "8632.93",
"close": "8899.31",
"volume": "12091.06145914"
},
/* ... */
],
"result": "success",
"continuation_token": "rbd2bcDp35GmDscQbvZ9YzQHZJkT3jdeFx9fSBDdVmcCZaHvQRTCTfmfQ6QCrvDNp5ciRRuGPTedVL5LMZv1qmSXhRpZFbpvBW2uA62RSYpfJ1hVykJKZfhtmXXrxz",
"next_url": "https://us.market-api.kaiko.io/v2/data/trades.v1/exchanges/krkn/spot/btc-usd/aggregations/ohlcv?continuation_token=rbd2bcDp35GmDqdfaz3fZJkT3jdeFx9fSBDdVmcCZaHvQRTCTfmfQ6QCrvDNp5ciRRuGPTedVL5LMZv1qmSXhRpZFbpvBW2uA62RSYpfJ1hVykJKZfhtmXXrxz",
"access": {
"access_range": {
"start_timestamp": null,
"end_timestamp": null
},
"data_range": {
"start_timestamp": null,
"end_timestamp": null
}
}
}
curl --compressed -H 'Accept: application/json' -H 'X-Api-Key: <client-api-key>' \
https://us.market-api.kaiko.io/v2/data/order_book_snapshots.v1/exchanges/krkn/spot/btc-usd/snapshots/slippage?end_time=2019-12-09T00:00:00Z&slippage_ref=best&start_time=2019-12-01T00:00:00Z&slippage=1000000&page_size=10'##### 1. Import dependencies #####
import requests
import pandas as pd
##### 2. Choose the value of the query's parameters #####
# ---- Required parameters ---- #
exchange = "krkn"
instrument_class = "spot"
pair = "btc-usd" #called "instrument" in the documentation
# ---- Optional parameters ---- #
sort = "desc"
page_size = 100
start_time= "2025-03-03T00:00:00Z"
end_time= "2025-03-05T00:00:00Z"
# ---- API key configuration ---- #
api_key = "YOUR_API_KEY"
##### 3. Get the data #####
# ---- Function to run an API call ---- #
# Get the data in a dataframe --------- #
def get_kaiko_data(api_key: str, exchange: str, pair: str, instrument_class: str, start_time: str, end_time: str, sort: str, page_size: int):
headers = {'Accept': 'application/json', 'X-Api-Key': api_key}
url = f'https://us.market-api.kaiko.io/v2/data/order_book_snapshots.v1/exchanges/{exchange}/{instrument_class}/{pair}/snapshots/slippage'
params = {
"start_time": start_time,
"end_time": end_time,
"sort": sort,
"page_size": page_size
}
try:
res = requests.get(url, headers=headers, params=params)
res.raise_for_status()
data = res.json()
if 'data' not in data:
print("No data returned.")
return pd.DataFrame()
df = pd.DataFrame(data['data'])
# Handle pagination with continuation token
while 'next_url' in data:
next_url = data['next_url']
if next_url is None:
break
res = requests.get(next_url, headers=headers)
res.raise_for_status()
data = res.json()
if 'data' in data:
df = pd.concat([df, pd.DataFrame(data['data'])], ignore_index=True)
return df
except requests.exceptions.RequestException as e:
print(f"API request error: {e}")
return pd.DataFrame()
# ---- Get the data ---- #
df = get_kaiko_data(api_key=api_key, exchange=exchange, pair=pair, instrument_class=instrument_class, start_time=start_time, end_time=end_time ,sort=sort, page_size=int(page_size))https://us.market-api.kaiko.io/v2/data/order_book_snapshots.v1/exchanges/{exchange}/{instrument_class}/{instrument}/snapshots/slippage{
"query": {
"page_size": 10,
"exchange": "krkn",
"instrument_class": "spot",
"instrument": "btc-usd",
"slippage": 100000,
"limit_orders": 0,
"slippage_ref": "best",
"sort": "desc",
"metric": "slippage",
"data_version": "v1",
"commodity": "order_book_snapshots",
"request_time": "2020-05-26T14:42:17.053Z"
},
"time": "2020-05-26T14:42:17.123Z",
"timestamp": 1590504137123,
"data": [
{
"poll_timestamp": 1590504124917,
"poll_date": "2020-05-26T14:42:04.917Z",
"timestamp": null,
"ask_slippage": "0.0001057219873253085790064266041007855",
"bid_slippage": "0.0001581287020485902479395059349031256"
},
{
"poll_timestamp": 1590504075786,
"poll_date": "2020-05-26T14:41:15.786Z",
"timestamp": null,
"ask_slippage": "0.00001534073225141691226479256404443437",
"bid_slippage": "0.0002555856086571344339622641509433962"
},
/* ... */
],
"result": "success",
"continuation_token": "Z8Fj1yUWjj3uvv1U2d8fASeGLm4jZ4iHCopdsZLKUyDJE8KrBaDXwQQWXHJQxm",
"next_url": "https://us.market-api.kaiko.io/v2/data/order_book_snapshots.v1/exchanges/cbse/spot/btc-usd/snapshots/slippage?continuation_token=Z8Fj1yUWjj3uvv1U2d8fASeGLm4jZ4iHCopdsZLKUyDJE8KrBaDXwQQWXHJQxm",
"access": {
"access_range": {
"start_timestamp": null,
"end_timestamp": null
},
"data_range": {
"start_timestamp": null,
"end_timestamp": null
}
}
} 'https://us.market-api.kaiko.io/v2/data/order_book_snapshots.v1/exchanges/krkn/spot/btc-usd/ob_aggregations/slippage?page_size=10&slippage=100000&interval=1h'##### 1. Import dependencies #####
import requests
import pandas as pd
##### 2. Choose the value of the query's parameters #####
# ---- Required parameters ---- #
exchange = "krkn"
instrument_class = "spot"
pair = "btc-usd" #called "instrument" in the documentation
# ---- Optional parameters ---- #
sort = "desc"
page_size = 100
start_time= "2025-01-03T00:00:00Z"
end_time= "2025-03-05T00:00:00Z"
slippage = 1000
slippage_ref = "mid_price"
# ---- API key configuration ---- #
api_key = "YOUR_API_KEY"
##### 3. Get the data #####
# ---- Function to run an API call ---- #
# Get the data in a dataframe --------- #
def get_kaiko_data(api_key: str, exchange: str, pair: str, instrument_class: str, start_time: str, end_time: str, sort: str, page_size: int, slippage: int, slippage_ref: str):
headers = {'Accept': 'application/json', 'X-Api-Key': api_key}
url = f'https://us.market-api.kaiko.io/v2/data/order_book_snapshots.v1/exchanges/{exchange}/{instrument_class}/{pair}/ob_aggregations/slippage'
params = {
"start_time": start_time,
"end_time": end_time,
"sort": sort,
"page_size": page_size,
"slippage": slippage,
"slippage_ref": slippage_ref
}
try:
res = requests.get(url, headers=headers, params=params)
res.raise_for_status()
data = res.json()
if 'data' not in data:
print("No data returned.")
return pd.DataFrame()
df = pd.DataFrame(data['data'])
# Handle pagination with continuation token
while 'next_url' in data:
next_url = data['next_url']
if next_url is None:
break
res = requests.get(next_url, headers=headers)
res.raise_for_status()
data = res.json()
if 'data' in data:
df = pd.concat([df, pd.DataFrame(data['data'])], ignore_index=True)
return df
except requests.exceptions.RequestException as e:
print(f"API request error: {e}")
return pd.DataFrame()
# ---- Get the data ---- #
df = get_kaiko_data(api_key=api_key, exchange=exchange, pair=pair, instrument_class=instrument_class, start_time=start_time, end_time=end_time ,sort=sort, page_size=int(page_size), slippage=slippage, slippage_ref=slippage_ref)message = "hello world"
puts messagehttps://us.market-api.kaiko.io/v2/data/order_book_snapshots.v1/exchanges/{exchange}/{instrument_class}/{instrument}/ob_aggregations/slippage{
"query": {
"page_size": 10,
"exchange": "krkn",
"instrument_class": "spot",
"instrument": "btc-usd",
"interval": "1h",
"slippage": 100000,
"slippage_ref": "mid_price",
"sort": "desc",
"aggregation": "slippage",
"data_version": "v1",
"commodity": "order_book_snapshots",
"request_time": "2020-05-26T15:07:06.840Z"
},
"time": "2020-05-26T15:07:07.260Z",
"timestamp": 1590505627260,
"data": [
{
"poll_timestamp": 1590505200000,
"ask_slippage": "0.00012513598764468878",
"bid_slippage": "0.0003678539692963374"
},
{
"poll_timestamp": 1590501600000,
"ask_slippage": "0.00030969034268815156",
"bid_slippage": "0.00024353107110561094"
},
/* ... */
],
"result": "success",
"access": {
"access_range": {
"start_timestamp": null,
"end_timestamp": null
},
"data_range": {
"start_timestamp": null,
"end_timestamp": null
}
}
}curl --compressed -H 'Accept: application/json' -H 'X-Api-Key: <client-api-key>' \
'https://us.market-api.kaiko.io/v2/data/order_book_snapshots.v1/exchanges/krkn/spot/btc-usd/snapshots/raw?page_size=10&limit_orders=2'##### 1. Import dependencies #####
import requests
import pandas as pd
##### 2. Choose the value of the query's parameters #####
# ---- Required parameters ---- #
exchange = "krkn"
instrument_class = "spot"
pair = "btc-usd" #called "instrument" in the documentation
# ---- Optional parameters ---- #
sort = "desc"
page_size = 100
start_time= "2025-03-03T00:00:00Z"
end_time= "2025-03-05T00:00:00Z"
limit_orders = 10
# ---- API key configuration ---- #
api_key = "YOUR_API_KEY"
##### 3. Get the data #####
# ---- Function to run an API call ---- #
# Get the data in a dataframe --------- #
def get_kaiko_data(api_key: str, exchange: str, pair: str, instrument_class: str, start_time: str, end_time: str, sort: str, page_size: int, limit_orders: int):
headers = {'Accept': 'application/json', 'X-Api-Key': api_key}
url = f'https://us.market-api.kaiko.io/v2/data/order_book_snapshots.v1/exchanges/{exchange}/{instrument_class}/{pair}/snapshots/raw'
params = {
"start_time": start_time,
"end_time": end_time,
"sort": sort,
"page_size": page_size,
"limit_orders": limit_orders
}
try:
res = requests.get(url, headers=headers, params=params)
res.raise_for_status()
data = res.json()
if 'data' not in data:
print("No data returned.")
return pd.DataFrame()
df = pd.DataFrame(data['data'])
# Handle pagination with continuation token
while 'next_url' in data:
next_url = data['next_url']
if next_url is None:
break
res = requests.get(next_url, headers=headers)
res.raise_for_status()
data = res.json()
if 'data' in data:
df = pd.concat([df, pd.DataFrame(data['data'])], ignore_index=True)
return df
except requests.exceptions.RequestException as e:
print(f"API request error: {e}")
return pd.DataFrame()
# ---- Get the data ---- #
df = get_kaiko_data(api_key=api_key, exchange=exchange, pair=pair, instrument_class=instrument_class, start_time=start_time, end_time=end_time ,sort=sort, page_size=int(page_size), limit_orders=limit_orders)https://us.market-api.kaiko.io/v2/data/order_book_snapshots.v1/exchanges/{exchange}/{instrument_class}/{instrument}/snapshots/raw{
"query": {
"page_size": 10,
"exchange": "krkn",
"instrument_class": "spot",
"instrument": "btc-usd",
"slippage": 0,
"limit_orders": 2,
"slippage_ref": "mid_price",
"sort": "desc",
"metric": "raw",
"data_version": "v1",
"commodity": "order_book_snapshots",
"request_time": "2020-05-26T14:13:08.823Z"
},
"time": "2020-05-26T14:13:08.899Z",
"timestamp": 1590502388899,
"data": [
{
"poll_timestamp": 1590502335760,
"poll_date": "2020-05-26T14:12:15.760Z",
"timestamp": null,
"asks": [
{
"amount": "12",
"price": "8830"
},
{
"amount": "3.67",
"price": "8832.9"
}
],
"bids": [
{
"amount": "13.316",
"price": "8829.9"
},
{
"amount": "0.097",
"price": "8829.4"
}
]
}
/* ... */
],
"result": "success",
"continuation_token": "Z8FjTagUoHd3UCqMvqmRJXlwzbTxSnSXpxxZpHWNCmrsrcnhSpMG2gdcmFKRPd88",
"next_url": "https://us.market-api.kaiko.io/v2/data/order_book_snapshots.v1/exchanges/cbse/spot/btc-usd/snapshots/raw?continuation_token=Z8FjTagUoHd3UCqMvqmRJXlwzbTxSnSXpxxZpHWNCmrsrcnhSpMG2gdcmFKRPd88",
"access": {
"access_range": {
"start_timestamp": null,
"end_timestamp": null
},
"data_range": {
"start_timestamp": null,
"end_timestamp": null
}
}
}curl --compressed -H 'Accept: application/json' -H 'X-Api-Key: <client-api-key>' \
'https://us.market-api.kaiko.io/v2/data/analytics.v2/value_at_risk?bases=eth,btc,ltc&quantities=3,2,5"e=usd&risk_level=0.95&start_time=2025-12-01T00:00:00.000Z&end_time=2025-12-05T00:00:00.000Z&stress_parameter=0.5'##### 1. Import dependencies #####
import requests
import pandas as pd
##### 2. Choose the value of the query's parameters #####
# ---- Required parameters ---- #
bases = "btc,eth"
quote = "usd"
quantities = "1,10"
risk_level = "0.95"
start_time = "2021-12-01T00:00:00.000Z"
end_time = "2022-01-31T00:00:00.000Z"
# ---- Optional parameters ---- #
sources = None
# ---- API key configuration ---- #
api_key = "YOUR_API_KEY"
##### 3. Get the data #####
# ---- Function to run an API call ---- #
# Get the data in a dataframe --------- #
def get_kaiko_data(api_key: str, bases: str, quote: str, quantities: str, risk_level: str, start_time: str, end_time: str, sources: bool = None):
headers = {'Accept': 'application/json', 'X-Api-Key': api_key}
url = f'https://us.market-api.kaiko.io/v2/data/analytics.v2/value_at_risk'
params = {
"bases": bases,
"quote": quote,
"quantities": quantities,
"risk_level": risk_level,
"start_time": start_time,
"end_time": end_time,
"sources": sources
}
try:
res = requests.get(url, headers=headers, params=params)
res.raise_for_status()
data = res.json()
if 'data' not in data:
print("No data returned.")
return pd.DataFrame()
df = pd.DataFrame(data['data'])
# Handle pagination with continuation token
while 'next_url' in data:
next_url = data['next_url']
if next_url is None:
break
res = requests.get(next_url, headers=headers)
res.raise_for_status()
data = res.json()
if 'data' in data:
df = pd.concat([df, pd.DataFrame(data['data'])], ignore_index=True)
return df
except requests.exceptions.RequestException as e:
print(f"API request error: {e}")
return pd.DataFrame()
# ---- Get the data ---- #
df = get_kaiko_data(api_key=api_key, bases=bases, quote=quote, quantities=quantities, risk_level=risk_level, start_time=start_time, end_time=end_time, sources=sources)
print (df)https://us.market-api.kaiko.io/v2/data/analytics.v2/value_at_risk{
"query": {
"bases": "eth,btc,ltc",
"quote": "usd",
"quantities": [
3,
2,
5
],
"exchanges": "",
"risk_level": 0.95,
"sources": false,
"data_version": "v2",
"commodity": "analytics",
"request_time": "2026-04-01T14:02:10.954Z",
"reporting_currency": ""
},
"time": "2026-04-01T14:02:11.316Z",
"timestamp": 1775052131316,
"data": [
{
"var_time": 1764547200000,
"value_at_risk": {
"value": 14051.3051028357,
"risk_level": 0.95
}
},
{
"var_time": 1764633600000,
"value_at_risk": {
"value": 13896.656231419009,
"risk_level": 0.95
}
},
{
"var_time": 1764720000000,
"value_at_risk": {
"value": 14243.618215415132,
"risk_level": 0.95
}
},
{
"var_time": 1764806400000,
"value_at_risk": {
"value": 14366.155261745589,
"risk_level": 0.95
}
},
{
"var_time": 1764892800000,
"value_at_risk": {
"value": 14317.703400730708,
"risk_level": 0.95
}
}
],
"start_date": "2021-12-01T00:00:00.000Z",
"access": {
"access_range": {
"start_timestamp": 1763683200,
"end_timestamp": null
},
"data_range": {
"start_timestamp": null,
"end_timestamp": null
}
}
}curl --compressed -H 'Accept: application/json' -H 'X-Api-Key: <client-api-key>' \
'https://us.market-api.kaiko.io/v2/data/analytics.v2/expected_shortfall?bases=eth,btc,ltc&quantities=3,2,5"e=usd&risk_level=0.95&start_time=2025-12-01T00:00:00.000Z&end_time=2025-12-05T00:00:00.000Z&stress_parameter=0.5&reporting_currency=eur'##### 1. Import dependencies #####
import requests
import pandas as pd
##### 2. Choose the value of the query's parameters #####
# ---- Required parameters ---- #
bases = "btc,eth"
quote = "usd"
quantities = "1,10"
risk_level = "0.95"
start_time = "2021-12-01T00:00:00.000Z"
end_time = "2022-01-31T00:00:00.000Z"
# ---- Optional parameters ---- #
sources = None
# ---- API key configuration ---- #
api_key = "YOUR_API_KEY"
##### 3. Get the data #####
# ---- Function to run an API call ---- #
# Get the data in a dataframe --------- #
def get_kaiko_data(api_key: str, bases: str, quote: str, quantities: str, risk_level: str, start_time: str, end_time: str, sources: bool = None):
headers = {'Accept': 'application/json', 'X-Api-Key': api_key}
url = f'https://us.market-api.kaiko.io/v2/data/analytics.v2/expected_shortfall'
params = {
"bases": bases,
"quote": quote,
"quantities": quantities,
"risk_level": risk_level,
"start_time": start_time,
"end_time": end_time,
"sources": sources
}
try:
res = requests.get(url, headers=headers, params=params)
res.raise_for_status()
data = res.json()
if 'data' not in data:
print("No data returned.")
return pd.DataFrame()
df = pd.DataFrame(data['data'])
# Handle pagination with continuation token
while 'next_url' in data:
next_url = data['next_url']
if next_url is None:
break
res = requests.get(next_url, headers=headers)
res.raise_for_status()
data = res.json()
if 'data' in data:
df = pd.concat([df, pd.DataFrame(data['data'])], ignore_index=True)
return df
except requests.exceptions.RequestException as e:
print(f"API request error: {e}")
return pd.DataFrame()
# ---- Get the data ---- #
df = get_kaiko_data(api_key=api_key, bases=bases, quote=quote, quantities=quantities, risk_level=risk_level, start_time=start_time, end_time=end_time, sources=sources)
print (df)https://us.market-api.kaiko.io/v2/data/analytics.v2/expected_shortfall{
"query": {
"bases": "eth,btc,ltc",
"quote": "usd",
"quantities": [
3,
2,
5
],
"exchanges": "",
"risk_level": 0.95,
"sources": false,
"data_version": "v2",
"commodity": "analytics",
"request_time": "2026-04-01T14:29:00.536Z",
"reporting_currency": "eur"
},
"time": "2026-04-01T14:29:00.825Z",
"timestamp": 1775053740825,
"data": [
{
"es_time": 1764547200000,
"expected_shortfall": {
"value": 13337.396618466695,
"risk_level": 0.95
}
},
{
"es_time": 1764633600000,
"expected_shortfall": {
"value": 13193.145029429792,
"risk_level": 0.95
}
},
{
"es_time": 1764720000000,
"expected_shortfall": {
"value": 13476.064947481469,
"risk_level": 0.95
}
},
{
"es_time": 1764806400000,
"expected_shortfall": {
"value": 13587.247396977718,
"risk_level": 0.95
}
},
{
"es_time": 1764892800000,
"expected_shortfall": {
"value": 13553.701550483325,
"risk_level": 0.95
}
}
],
"access": {
"access_range": {
"start_timestamp": 1763683200,
"end_timestamp": null
},
"data_range": {
"start_timestamp": null,
"end_timestamp": null
}
}
}curl --compressed -H 'Accept: application/json' -H 'X-Api-Key: <client-api-key>' \
'https://us.market-api.kaiko.io/v2/data/supply.v2/assets/btc?start_time=2025-11-12T14:00:00.000Z&page_size=100&sources=true&sort=desc'import http.client
import json
# Enter your Kaiko API Key
api_key = "KAIKO_API_KEY"
api_host = "us.market-api.kaiko.io"
api_base_endpoint = "/v2/data/supply.v2/assets/btc"
# Start of mandatory parameter configuration
mandatory_params = {
}
# End of mandatory parameter configuration
# Start of optional parameter configuration
optional_params = {
'start_time':'2025-11-12T14:00:00.000Z',
'page_size':100,
'sort':'desc',
'sources':'true'
}
# End of optional parameter configuration
conn = http.client.HTTPSConnection(api_host)
headers = {
"X-Api-Key": api_key,
"Accept": "application/json"
}
all_params = {**mandatory_params, **optional_params}
url_params = []
for param, value in all_params.items():
url_params.append(f"{param}={value}")
url_params = '&'.join(url_params)
endpoint_with_params = f"{api_base_endpoint}?{url_params}"
# Pagination for next pages
all_data = []
next_url = endpoint_with_params
while next_url:
conn.request("GET", next_url, headers=headers)
response = conn.getresponse()
data = json.loads(response.read().decode("utf-8"))
all_data.extend(data.get("data", []))
print(f"Fetched {len(data.get('data', []))} datapoints. Total: {len(all_data)}")
next_url = data.get("next_url", "").replace("https://us.market-api.kaiko.io", "")
if not next_url:
break
conn.close()
print(f" datapoints fetched: {(all_data)}")https://us.market-api.kaiko.io/v2/data/supply.v2/assets/{asset}{
"query":
{
"start_time": "2025-11-12T14:00:00.000Z",
"end_time": "2025-11-12T14:00:48.317Z",
"page_size": 100,
"asset": "btc",
"sort": "desc",
"request_time": "2025-11-12T14:00:48.317Z",
"start_timestamp": 1735689600000,
"end_timestamp": 1762956048317
},
"time": "2025-11-12T14:00:48.326Z",
"timestamp": 1762956048326,
"data":
[
{
"timestamp": 1762956005,
"asset": "btc",
"circulating_supply": 19947809.375,
"market_cap": 2093053874177.4607,
"sources":
[
{
"chain": "Bitcoin",
"circulating_supply": "19947809.375",
"excluded_supply": "0",
"total_supply": "19947809.375"
}
]
}
/** Results **/
],
"result": "success",
"continuation_token": "xxx",
"next_url": "https://us.market-api.kaiko.io/v2/data/supply.v2/assets/btc?continuation_token=xxx",
"access":
{
"access_range":
{
"start_timestamp": 1073001600000,
"end_timestamp": "None"
},
"data_range":
{
"start_timestamp": "None",
"end_timestamp": "None"
}
}
}
Derivatives price endpoint
https://eu.market-api.kaiko.io/v2/data/derivatives.v2/pricehttps://<eu|us>.market-api.kaiko.io/v2/data/trades.v1/exchanges/{exchange}/{instrument_class}/{instrument}/aggregations/count_ohlcv_vwapcurl --compressed -H 'Accept: application/json' -H 'X-Api-Key: <client-api-key>' \
'https://us.market-api.kaiko.io/v2/data/trades.v1/exchanges/cbse/spot/btc-usd/aggregations/count_ohlcv_vwap'```python
##### 1. Import dependencies #####
import requests
import pandas as pd
##### 2. Choose the value of the query's parameters #####
# ---- Required parameters ---- #
exchange = "cbse"
instrument_class = "spot"
pair = "btc-usd" #called "instrument" in the documentation
# ---- Optional parameters ---- #
interval = "1d"
sort = "desc"
page_size = 100
start_time= "2023-01-01T00:00:00Z"
end_time= "2023-12-31T23:59:59Z"
# ---- API key configuration ---- #
api_key = "YOUR_API_KEY"
##### 3. Get the data #####
# ---- Function to run an API call ---- #
# Get the data in a dataframe --------- #
def get_kaiko_data(api_key: str, exchange: str, pair: str, instrument_class: str, start_time: str, end_time: str, interval: str, sort: str, page_size: int):
headers = {'Accept': 'application/json', 'X-Api-Key': api_key}
url = f'https://us.market-api.kaiko.io/v2/data/trades.v1/exchanges/{exchange}/{instrument_class}/{pair}/aggregations/count_ohlcv_vwap'
params = {
"start_time": start_time,
"end_time": end_time,
"sort": sort,
"page_size": page_size,
"interval": interval
}
try:
res = requests.get(url, headers=headers, params=params)
res.raise_for_status()
data = res.json()
if 'data' not in data:
print("No data returned.")
return pd.DataFrame()
df = pd.DataFrame(data['data'])
# Handle pagination with continuation token
while 'next_url' in data:
res = requests.get(data['next_url'], headers=headers)
res.raise_for_status()
data = res.json()
if 'data' in data:
df = pd.concat([df, pd.DataFrame(data['data'])], ignore_index=True)
return df
except requests.exceptions.RequestException as e:
print(f"API request error: {e}")
return pd.DataFrame()
# ---- Get the data ---- #
df = get_kaiko_data(api_key=api_key, exchange=exchange, pair=pair, instrument_class=instrument_class, start_time=start_time, end_time=end_time ,interval=interval, sort=sort, page_size=page_size)
```{
"query": {
"page_size": 100,
"exchange": "cbse",
"instrument_class": "spot",
"instrument": "btc-usd",
"interval": "1d",
"sort": "desc",
"aggregation": "count_ohlcv_vwap",
"data_version": "v1",
"commodity": "trades",
"request_time": "2020-11-12T16:55:42.588Z"
},
"time": "2020-11-12T16:55:42.710Z",
"timestamp": 1605200142710,
"data": [
{
"timestamp": 1605139200000,
"open": "15705.79",
"high": "16185.87",
"low": "15446.82",
"close": "16139.93",
"volume": "14829.124546730012",
"price": "15880.01873841608",
"count": 95111
},
{
"timestamp": 1605052800000,
"open": "15315.46",
"high": "16000",
"low": "15293.04",
"close": "15705.79",
"volume": "15123.844197729988",
"price": "15664.643871798791",
"count": 114205
},
/* ... */
],
"result": "success",
"continuation_token": "rbd1XbkjMwv2SyUfvJwsqFGmCKzg3WToTvqigui1bejckYnxd9DM1V3v58iqMCdXa4dJSXap6p6fBuvzz32tiHVrv5LC76MyRyYNbZyvSEoVzd1krSWWeXYEtEtR",
"next_url": "https://<eu|us>.market-api.kaiko.io/v2/data/trades.v1/exchanges/cbse/spot/btc-usd/aggregations/count_ohlcv_vwap?continuation_token=rbd1XbkjMwv2SyUfvJwsui1bejckYnxd9DM1V3v58iqMCdXa4dJSXap6p6fBuvzz32tiHVrv5LC76MyRyYNbZyvSEoVzd1krSWWeXYEtEtR",
"access": {
"access_range": {
"start_timestamp": 1546300800000,
"end_timestamp": 1577836800000
},
"data_range": {
"start_timestamp": 1417391000000,
"end_timestamp": 1577836800000
}
}
}
https://us.market-api.kaiko.io/v2/data/order_book_snapshots.v1/exchanges/{exchange}/{instrument_class}/{instrument}/snapshots/depthcurl --compressed -H 'Accept: application/json' -H 'X-Api-Key: <client-api-key>' \
'https://us.market-api.kaiko.io/v2/data/order_book_snapshots.v1/exchanges/krkn/spot/btc-usd/snapshots/depth?page_size=10'##### 1. Import dependencies #####
import requests
import pandas as pd
##### 2. Choose the value of the query's parameters #####
# ---- Required parameters ---- #
exchange = "krkn"
instrument_class = "spot"
pair = "btc-usd" #called "instrument" in the documentation
# ---- Optional parameters ---- #
sort = "desc"
page_size = 100
start_time= "2025-03-03T00:00:00Z"
end_time= "2025-03-05T00:00:00Z"
# ---- API key configuration ---- #
api_key = "YOUR_API_KEY"
##### 3. Get the data #####
# ---- Function to run an API call ---- #
# Get the data in a dataframe --------- #
def get_kaiko_data(api_key: str, exchange: str, pair: str, instrument_class: str, start_time: str, end_time: str, sort: str, page_size: int):
headers = {'Accept': 'application/json', 'X-Api-Key': api_key}
url = f'https://us.market-api.kaiko.io/v2/data/order_book_snapshots.v1/exchanges/{exchange}/{instrument_class}/{pair}/snapshots/depth'
params = {
"start_time": start_time,
"end_time": end_time,
"sort": sort,
"page_size": page_size
}
try:
res = requests.get(url, headers=headers, params=params)
res.raise_for_status()
data = res.json()
if 'data' not in data:
print("No data returned.")
return pd.DataFrame()
df = pd.DataFrame(data['data'])
# Handle pagination with continuation token
while 'next_url' in data:
next_url = data['next_url']
if next_url is None:
break
res = requests.get(next_url, headers=headers)
res.raise_for_status()
data = res.json()
if 'data' in data:
df = pd.concat([df, pd.DataFrame(data['data'])], ignore_index=True)
return df
except requests.exceptions.RequestException as e:
print(f"API request error: {e}")
return pd.DataFrame()
# ---- Get the data ---- #
df = get_kaiko_data(api_key=api_key, exchange=exchange, pair=pair, instrument_class=instrument_class, start_time=start_time, end_time=end_time ,sort=sort, page_size=int(page_size)){
"query": {
"page_size": 10,
"exchange": "krkn",
"instrument_class": "spot",
"instrument": "btc-usd",
"slippage": 0,
"limit_orders": 0,
"slippage_ref": "mid_price",
"sort": "desc",
"metric": "depth",
"data_version": "v1",
"commodity": "order_book_snapshots",
"request_time": "2020-05-26T14:29:44.757Z"
},
"time": "2020-05-26T14:29:44.816Z",
"timestamp": 1590503384816,
"data": [
{
"poll_timestamp": 1590503344916,
"poll_date": "2020-05-26T14:29:04.916Z",
"timestamp": null,
"bid_volume0_1": "37.606",
"bid_volume0_2": "102.304",
"bid_volume0_3": "141.907",
"bid_volume0_4": "177.446",
"bid_volume0_5": "203.634",
"bid_volume0_6": "218.450",
"bid_volume0_7": "283.128",
"bid_volume0_8": "293.533",
"bid_volume0_9": "321.986",
"bid_volume1": "348.213",
"bid_volume1_5": "405.080",
"bid_volume2": "444.782",
"bid_volume4": "837.949",
"bid_volume6": "1110.065",
"bid_volume8": "1110.065",
"bid_volume10": "1110.065",
"ask_volume0_1": "7.401",
"ask_volume0_2": "13.744",
"ask_volume0_3": "58.917",
"ask_volume0_4": "131.104",
"ask_volume0_5": "165.971",
"ask_volume0_6": "193.786",
"ask_volume0_7": "257.001",
"ask_volume0_8": "286.384",
"ask_volume0_9": "312.040",
"ask_volume1": "319.040",
"ask_volume1_5": "382.927",
"ask_volume2": "475.467",
"ask_volume4": "909.144",
"ask_volume6": "1229.664",
"ask_volume8": "1323.505",
"ask_volume10": "1323.505"
},
/* ... */
],
"result": "success",
"continuation_token": "Z8FjYwcAjf7MZEG382e5MpmZx7wkuziQTyy2k5fVgSrcF8jAYqUpRgPH5cbQ9MhJiFaxGRbwiERMp3cWhXJshy",
"next_url": "https://us.market-api.kaiko.io/v2/data/order_book_snapshots.v1/exchanges/cbse/spot/btc-usd/snapshots/depth?continuation_token=Z8FjYwcAjf7MZEG382e5MpmZx7wkuziQTyy2k5fVgSrcF8jAYqUpRgPH5cbQ9MhJiFaxGRbwiERMp3cWhXJshy",
"access": {
"access_range": {
"start_timestamp": null,
"end_timestamp": null
},
"data_range": {
"start_timestamp": null,
"end_timestamp": null
}
}
} curl --compressed -H 'Accept: application/json' -H 'X-Api-Key: <client-api-key>' \
'https://us.market-api.kaiko.io/v2/data/order_book_snapshots.v1/exchanges/krkn/spot/btc-usd/ob_aggregations/depth?page_size=10&interval=1h'##### 1. Import dependencies #####
import requests
import pandas as pd
##### 2. Choose the value of the query's parameters #####
# ---- Required parameters ---- #
exchange = "krkn"
instrument_class = "spot"
pair = "btc-usd" #called "instrument" in the documentation
# ---- Optional parameters ---- #
sort = "desc"
page_size = 100
start_time= "2025-03-03T00:00:00Z"
end_time= "2025-03-05T00:00:00Z"
# ---- API key configuration ---- #
api_key = "YOUR_API_KEY"
##### 3. Get the data #####
# ---- Function to run an API call ---- #
# Get the data in a dataframe --------- #
def get_kaiko_data(api_key: str, exchange: str, pair: str, instrument_class: str, start_time: str, end_time: str, sort: str, page_size: int):
headers = {'Accept': 'application/json', 'X-Api-Key': api_key}
url = f'https://us.market-api.kaiko.io/v2/data/order_book_snapshots.v1/exchanges/{exchange}/{instrument_class}/{pair}/ob_aggregations/depth'
params = {
"start_time": start_time,
"end_time": end_time,
"sort": sort,
"page_size": page_size
}
try:
res = requests.get(url, headers=headers, params=params)
res.raise_for_status()
data = res.json()
if 'data' not in data:
print("No data returned.")
return pd.DataFrame()
df = pd.DataFrame(data['data'])
# Handle pagination with continuation token
while 'next_url' in data:
next_url = data['next_url']
if next_url is None:
break
res = requests.get(next_url, headers=headers)
res.raise_for_status()
data = res.json()
if 'data' in data:
df = pd.concat([df, pd.DataFrame(data['data'])], ignore_index=True)
return df
except requests.exceptions.RequestException as e:
print(f"API request error: {e}")
return pd.DataFrame()
# ---- Get the data ---- #
df = get_kaiko_data(api_key=api_key, exchange=exchange, pair=pair, instrument_class=instrument_class, start_time=start_time, end_time=end_time ,sort=sort, page_size=int(page_size))message = "hello world"
puts message{
"query": {
"page_size": 10,
"exchange": "krkn",
"instrument_class": "spot",
"instrument": "btc-usd",
"interval": "1h",
"slippage": 0,
"slippage_ref": "mid_price",
"sort": "desc",
"aggregation": "depth",
"data_version": "v1",
"commodity": "order_book_snapshots",
"request_time": "2020-05-26T14:58:55.582Z"
},
"time": "2020-05-26T14:58:56.395Z",
"timestamp": 1590505136395,
"data": [
{
"poll_timestamp": 1590501600000,
"bid_volume0_1": "31.31635593220339",
"bid_volume0_2": "90.78996610169492",
"bid_volume0_3": "144.16212711864407",
"bid_volume0_4": "182.9676525423729",
"bid_volume0_5": "219.1858220338983",
"bid_volume0_6": "263.02182203389833",
"bid_volume0_7": "296.666686440678",
"bid_volume0_8": "322.5334237288136",
"bid_volume0_9": "340.6282881355932",
"bid_volume1": "356.4558474576271",
"bid_volume1_5": "427.1106949152542",
"bid_volume2": "475.76238135593223",
"bid_volume4": "863.1048559322035",
"bid_volume6": "1137.2281271186441",
"bid_volume8": "1137.5447796610172",
"bid_volume10": "1137.5447796610172",
"ask_volume0_1": "22.772533898305085",
"ask_volume0_2": "36.96916101694915",
"ask_volume0_3": "78.57454237288135",
"ask_volume0_4": "144.87783898305085",
"ask_volume0_5": "195.61884745762714",
"ask_volume0_6": "237.96824576271186",
"ask_volume0_7": "282.3425338983051",
"ask_volume0_8": "314.0606779661017",
"ask_volume0_9": "330.76757627118644",
"ask_volume1": "344.3153644067797",
"ask_volume1_5": "413.4595423728814",
"ask_volume2": "475.48172033898305",
"ask_volume4": "886.8459152542373",
"ask_volume6": "1272.5998644067795",
"ask_volume8": "1371.7920847457626",
"ask_volume10": "1371.7920847457626"
},
/* ... */
],
"result": "success",
"access": {
"access_range": {
"start_timestamp": null,
"end_timestamp": null
},
"data_range": {
"start_timestamp": null,
"end_timestamp": null
}
}
}https://us.market-api.kaiko.io/v2/data/liquidity.v1/snapshotscurl --compressed -H 'Accept: application/json' -H 'X-Api-Key: KAIKO_API_KEY' \
'https://us.market-api.kaiko.io/v2/data/liquidity.v1/snapshots?pool_address=0x0d4a11d5eeaac28ec3f61d100daf4d40471f1852&start_block=129870&end_block=129880'##### 1. Import dependencies #####
import requests
import pandas as pd
##### 2. Choose the value of the query's parameters #####
# ---- Required parameters ---- #
pool_address = "0x0d4a11d5eeaac28ec3f61d100daf4d40471f1852"
# ---- Optional parameters ---- #
blockchain = "ethereum"
live = "false"
start_block = "129870"
end_block = "129880"
start_time = None
end_time = None
sort = "desc"
page_size = 100
# ---- API key configuration ---- #
api_key = "YOUR_API_KEY"
##### 3. Get the data #####
# ---- Function to run an API call ---- #
# Get the data in a dataframe --------- #
def get_kaiko_data(api_key: str, pool_address: str, blockchain: str, live: str, start_block: str, end_block: str, start_time: str, end_time: str, sort: str, page_size: int):
headers = {'Accept': 'application/json', 'X-Api-Key': api_key}
url = f'https://eu.market-api.kaiko.io/v2/data/liquidity.v1/snapshots'
params = {
"pool_address": pool_address,
"blockchain": blockchain,
"live": live,
"start_block": start_block,
"end_block": end_block,
"start_time": start_time,
"end_time": end_time,
"sort": sort,
"page_size": page_size
}
try:
res = requests.get(url, headers=headers, params=params)
res.raise_for_status()
data = res.json()
if 'data' not in data:
print("No data returned.")
return pd.DataFrame()
df = pd.DataFrame(data['data'])
# Handle pagination with continuation token
while 'next_url' in data:
next_url = data['next_url']
if next_url is None:
break
res = requests.get(next_url, headers=headers)
res.raise_for_status()
data = res.json()
if 'data' in data:
df = pd.concat([df, pd.DataFrame(data['data'])], ignore_index=True)
return df
except requests.exceptions.RequestException as e:
print(f"API request error: {e}")
return pd.DataFrame()
# ---- Get the data ---- #
df = get_kaiko_data(api_key=api_key, pool_address=pool_address, blockchain=blockchain,
live=live, start_block=start_block, end_block=end_block,
start_time=start_time, end_time=end_time, sort=sort,
page_size=int(page_size)){
"query": {
"blockchain": "ethereum",
"protocol": "*",
"pool_address": "0x0d4a11d5eeaac28ec3f61d100daf4d40471f1852",
"start_block": "*",
"end_block": "*",
"start_time": "*",
"end_time": "*",
"live": "false",
"sort": "descending",
"page_size": "100",
"live": "false"
},
"time": "2025-03-31T11:16:39.168Z",
"timestamp": 1743419799,
"data": [
{
"block_number": "22166374",
"pool_name": "WETH-USDT",
"pool_address": "0x0d4a11d5eeaac28ec3f61d100daf4d40471f1852",
"exchange": "usp2",
"price": 0.000553562,
"amounts":
[
{
"symbol": "WETH",
"address": "0xc02aaa39b223fe8d0a0e5c4f27ead9083c756cc2",
"amount": 3005.5794298594374
},
{
"symbol": "USDT",
"address": "0xdac17f958d2ee523a2206206994597c13d831ec7",
"amount": 5389884.464753
}
],
"datetime": 1743417755,
"blockchain": "ethereum"
},
...
],
"continuation_token": "xxx",
"next_url": "https://us.market-api.kaiko.io/v2/data/liquidity.v1/snapshots?continuation_token=xxx"
}curl --compressed -H 'Accept: application/json' 'https://reference-data-api.kaiko.io/v1/instruments'{
"result": "success",
"data": [
{
"kaiko_legacy_exchange_slug": "bf",
"trade_start_time": "2017-08-09T23:36:33.0000000Z",
"trade_end_time": null,
"code": "xmr-btc",
"exchange_code": "bfnx",
"exchange_pair_code": "XMRBTC",
"base_asset": "xmr",
"quote_asset": "btc",
"kaiko_legacy_symbol": "xmrbtc",
"class": "spot",
"trade_start_timestamp": 1502321793000,
"trade_end_timestamp": null,
"trade_count": 2439870,
"trade_compressed_size": 35037071
},
{
"kaiko_legacy_exchange_slug": "kk",
"trade_start_time": "2017-08-08T20:10:04.0000000Z",
"trade_end_time": null,
"code": "gno-eth",
"exchange_code": "krkn",
"exchange_pair_code": "GNOETH",
"base_asset": "gno",
"quote_asset": "eth",
"kaiko_legacy_symbol": "gnoeth",
"class": "spot",
"trade_start_timestamp": 1502223004345,
"trade_end_timestamp": null,
"trade_count": 380822,
"trade_compressed_size": 21119034
},
/* ... */
]
}curl --compressed -H 'Accept: application/json' -H 'X-Api-Key: <client-api-key>' \
'https://eu.market-api.kaiko.io/v2/data/derivatives.v2/price?exchange=okex&instrument_class=perpetual-future&instrument=btc-usdt&page_size=2'##### 1. Import dependencies #####
import requests
import pandas as pd
##### 2. Choose the value of the query's parameters #####
# ---- Required parameters ---- #
exchange = "okex"
instrument_class = "perpetual-future"
instrument = "btc-usdt"
# ---- Optional parameters ---- #
interval = "1h"
page_size = 10
sort = "asc"
start_time = None
end_time = None
# ---- API key configuration ---- #
api_key = "YOUR_API_KEY"
##### 3. Get the data #####
# ---- Function to run an API call ---- #
# Get the data in a dataframe --------- #
def get_kaiko_data(api_key: str, exchange: str, instrument_class: str, instrument: str, interval: str, page_size: int, sort: str, start_time: str, end_time: str):
headers = {'Accept': 'application/json', 'X-Api-Key': api_key}
url = f'https://eu.market-api.kaiko.io/v2/data/derivatives.v2/price'
params = {
"exchange": exchange,
"instrument_class": instrument_class,
"instrument": instrument,
"interval": interval,
"page_size": page_size,
"sort": sort,
"start_time": start_time,
"end_time": end_time
}
try:
res = requests.get(url, headers=headers, params=params)
res.raise_for_status()
data = res.json()
if 'data' not in data:
print("No data returned.")
return pd.DataFrame()
df = pd.DataFrame(data['data'])
# Handle pagination with continuation token
while 'next_url' in data:
next_url = data['next_url']
if next_url is None:
break
res = requests.get(next_url, headers=headers)
res.raise_for_status()
data = res.json()
if 'data' in data:
df = pd.concat([df, pd.DataFrame(data['data'])], ignore_index=True)
return df
except requests.exceptions.RequestException as e:
print(f"API request error: {e}")
return pd.DataFrame()
# ---- Get the data ---- #
df = get_kaiko_data(api_key=api_key, exchange=exchange, instrument_class=instrument_class, instrument=instrument, interval=interval, page_size=page_size, sort=sort, start_time=start_time, end_time=end_time)
print (df){
"query": {
"exchange": "okex",
"instrument_class": "perpetual-future",
"instrument": "btc-usdt",
"interval": "1m",
"page_size": 2,
"sort": "desc",
"data_version": "v2",
"commodity": "derivatives",
"request_time": "2022-04-28T12:36:34.981Z"
},
"time": "2022-04-28T12:36:37.166Z",
"timestamp": 1651149397166,
"data": [
{
"timestamp": 1651149360000,
"index_price": null,
"mark_price": "39707.8",
"price": "39709.7"
},
{
"timestamp": 1651149300000,
"index_price": "39713.3",
"mark_price": "39745.9",
"price": "39767"
}
],
/*---*/
"access": {
"access_range": {
"start_timestamp": 1646006400000,
"end_timestamp": null
},
"data_range": {
"start_timestamp": null,
"end_timestamp": null
}
}
}curl --compressed -H "Accept: application/json" -H "X-Api-Key: <client-api-key>" \
"https://eu.market-api.kaiko.io/v2/data/wallet.v1/transactions?blockchain=bitcoin"##### 1. Import dependencies #####
import requests
import pandas as pd
##### 2. Choose the value of the query's parameters #####
# ---- Required parameters ---- #
blockchain = "bitcoin"
# ---- Optional parameters ---- #
start_block = 600000
end_block = 600001
start_time = None
end_time = None
page_size = 100
sort = "desc"
transaction_hash = None
# ---- API key configuration ---- #
api_key = "YOUR_API_KEY"
##### 3. Get the data #####
# ---- Function to run an API call ---- #
# Get the data in a dataframe --------- #
def get_kaiko_data(api_key: str, blockchain: str, start_block: int, end_block: int, start_time: str, end_time: str, page_size: int, sort: str, transaction_hash: str):
headers = {'Accept': 'application/json', 'X-Api-Key': api_key}
url = f'https://us.market-api.kaiko.io/v2/data/wallet.v1/transactions'
params = {
"blockchain": blockchain,
"start_block": start_block,
"end_block": end_block,
"start_time": start_time,
"end_time": end_time,
"page_size": page_size,
"sort": sort,
"transaction_hash": transaction_hash
}
try:
res = requests.get(url, headers=headers, params=params)
res.raise_for_status()
data = res.json()
if 'data' not in data:
print("No data returned.")
return pd.DataFrame()
df = pd.DataFrame(data['data'])
# Handle pagination with continuation token
while 'next_url' in data:
next_url = data['next_url']
if next_url is None:
break
res = requests.get(next_url, headers=headers)
res.raise_for_status()
data = res.json()
if 'data' in data:
df = pd.concat([df, pd.DataFrame(data['data'])], ignore_index=True)
return df
except requests.exceptions.RequestException as e:
print(f"API request error: {e}")
return pd.DataFrame()
# ---- Get the data ---- #
df = get_kaiko_data(api_key=api_key, blockchain=blockchain, start_block=start_block, end_block=end_block, start_time=start_time, end_time=end_time, page_size=page_size, sort=sort, transaction_hash=transaction_hash)
print (df){
"query":
{
"live": "False",
"start_time": "2009-01-01T00:00:00.000Z",
"end_time": "2009-01-01T00:00:00.000Z",
"start_block": 0,
"end_block": 0,
"page_size": 1000,
"sort": "ASCENDING",
"data_version": "v1",
"commodity": "wallet_data",
"request_time": "2009-01-01T00:00:00.000Z"
},
"time": "2009-01-01T00:00:00.000Z",
"timestamp": 1704069091000,
"access":
{
"access_range":
{
"start_timestamp": 1073001600000,
"end_timestamp": "None"
},
"data_range":
{
"start_timestamp": "None",
"end_timestamp": "None"
}
},
"data":
[
{
"chain": "bitcoin",
"block_number": 823787,
"timestamp": 1704069091000000000,
"transaction_hash": "e651241e9982332ea4cf59923d8cbc7468e1960bb5ab9f68d9e72984830c530c",
"transaction_id": "e651241e9982332ea4cf59923d8cbc7468e1960bb5ab9f68d9e72984830c530c",
"transaction_index": 15,
"sender_addresses":
[
"1n8gms991ydy1e696e9sb9esyy5cksu7hz"
],
"receiver_addresses":
[
"1n8gms991ydy1e696e9sb9esyy5cksu7hz",
"3juadjkqtgzr9p9n59rtugv5pl2tohf6t9",
"bc1q5g4w7sajpqvd0syvghsqvrxcf2ysxce0yxqjkx"
],
"token_symbol": "BTC",
"amount_out": 0.37257751,
"fees": 0.0014,
"amount_out_usd": 15729.55,
"fees_usd": 59.1
},
/* ... */
],
"continuation_token": "xxx",
"next_url": "https://us.market-api.kaiko.io/v2/data/wallet.v1/transactions?continuation_token=xxx"
}
}curl --compressed -H 'Accept: application/json' -H 'X-Api-Key: <client-api-key>' \
'https://us.market-api.kaiko.io/v2/data/liquidation.v1/trades/bbit/perpetual-future/eth-usdt?start_time=2025-04-12T00:00:00Z&end_time=2025-04-12T08:00:00Z&page_size=10'##### 1. Import dependencies #####
import requests
import pandas as pd
from urllib.parse import urlencode
##### 2. Choose the value of the query's parameters #####
# ---- Required parameters ---- #
exchange = "bbit"
instrument_class = "perpetual-future"
instrument = "eth-usdt"
# ---- Optional parameters ---- #
page_size = 10
sort = "desc"
start_time = "2025-04-12T00:00:00Z"
end_time = "2025-04-12T08:00:00Z"
# ---- API key configuration ---- #
api_key = "YOUR_API_KEY"
##### 3. Get the data #####
# ---- Function to run an API call ---- #
# Get the data in a dataframe --------- #
def get_kaiko_liquidation_trades(api_key: str, exchange: str, instrument_class: str, instrument: str,
start_time: str, end_time: str, sort: str, page_size: int):
headers = {'Accept': 'application/json', 'X-Api-Key': api_key}
base_url = f'https://us.market-api.kaiko.io/v2/data/liquidation.v1/trades/{exchange}/{instrument_class}/{instrument}'
params = {
"start_time": start_time,
"end_time": end_time,
"sort": sort,
"page_size": page_size
}
# Debug: Show the URL being generated
query_string = urlencode(params)
full_url = f"{base_url}?{query_string}"
print(f"DEBUG - Making request to URL: {full_url}")
print(f"DEBUG - Headers: {headers}")
try:
res = requests.get(base_url, headers=headers, params=params)
# Debug: Show the actual URL that requests used
print(f"DEBUG - Actual request URL: {res.url}")
print(f"DEBUG - Response status code: {res.status_code}")
res.raise_for_status()
data = res.json()
if 'data' not in data:
print("No data returned.")
return pd.DataFrame()
df = pd.DataFrame(data['data'])
print(f"DEBUG - Initial data fetch successful, got {len(df)} records")
# Handle pagination with continuation token
page_count = 1
while 'next_url' in data:
next_url = data['next_url']
if next_url is None:
break
print(f"DEBUG - Fetching page {page_count + 1} with URL: {next_url}")
res = requests.get(next_url, headers=headers)
res.raise_for_status()
data = res.json()
if 'data' in data:
new_records = len(data['data'])
df = pd.concat([df, pd.DataFrame(data['data'])], ignore_index=True)
print(f"DEBUG - Fetched additional {new_records} records, total now: {len(df)}")
page_count += 1
else:
print("DEBUG - No more data in pagination response")
break
return df
except requests.exceptions.RequestException as e:
print(f"API request error: {e}")
print(f"Response status code: {e.response.status_code if hasattr(e, 'response') else 'N/A'}")
print(f"Response text: {e.response.text if hasattr(e, 'response') else 'N/A'}")
return pd.DataFrame()
# ---- Get the data ---- #
print("Starting API request...")
df = get_kaiko_liquidation_trades(
api_key=api_key,
exchange=exchange,
instrument_class=instrument_class,
instrument=instrument,
start_time=start_time,
end_time=end_time,
sort=sort,
page_size=page_size
)https://{region}.market-api.kaiko.io/v2/data/liquidation.v1/trades/{exchange}/{instrument_class}/{instrument}```json
{
"query": {
"exchange": "bbit",
"instrument": "eth-usdt",
"instrument_class": "perpetual-future",
"commodity": "liquidationEvents",
"request_time": "2025-04-04T11:58:32.545Z",
"start_time": "2025-02-12T00:00:01.000Z",
"start_timestamp": 1739318401000,
"end_time": "2025-02-24T23:59:37.000Z",
"end_timestamp": 1740441577000,
"page_size": 10,
"sort": "desc",
"data_version": "v1"
},
"answer_time": "2025-04-04T11:58:32.554Z",
"answer_timestamp": 1743767912554,
"access": {
"access_range": {
"start_timestamp": 1688428800000,
"end_timestamp": 2177539199000
},
"data_range": {
"start_timestamp": null,
"end_timestamp": null
}
},
"data": [
{
"amount": 0.1,
"amount_quote": 249.77100000000002,
"amount_usd": 249.76370743089532,
"price": 2497.71,
"rate": 0.9999708029791101,
"position_side": "long",
"timestamp": 1740441553739,
"trade_id": "376def42502a7a307b85d7ffdebec8c8c08990b19f6fb165e0f97c8fd058a1b2"
},
{
"amount": 0.04,
"amount_quote": 99.7556,
"amount_usd": 99.75268743366291,
"price": 2493.89,
"rate": 0.9999708029791101,
"position_side": "long",
"timestamp": 1740441446020,
"trade_id": "f1062a8c42743ffbddc3d129d65f1ae6848227b871361d6fd66f3bbbbb4b10da"
},
/*---*/
],
*/....
"continuation_token": "3RuQ1KYk3AEZTJXXqsaUMrdUKSYH4CVdGUFQCZC5pts7AYMafCjbnYSuedeLMFu72PsXKepcvdtpvZmNzXmotWV1ARAF8hJxLfaDXn75MmkN3zMq6ma9Ym",
"next_url": "https://us.market-api.kaiko.io/v2/data/liquidation.v1/trades/bbit/perpetual-future/eth-usdt?continuation_token=3RuQ1KYk3AEZTJXXqsaUMrdUKSYH4CVdGUFQCZC5pts7AYMafCjbnYSuedeLMFu72PsXKepcvdtpvZmNzXmotWV1ARAF8hJxLfaDXn75MmkN3zMq6ma9Ym"
}curl --compressed -H 'Accept: application/json' -H 'X-Api-Key: <client-api-key>' \
'https://us.market-api.kaiko.io/v2/data/order_book_snapshots.v1/exchanges/krkn/spot/btc-usd/ob_aggregations/full?page_size=10&slippage=100000&interval=1h&start_time=2019-12-04T00:00:00Z&end_time=2019-12-06T00:00:00Z'##### 1. Import dependencies #####
import requests
import pandas as pd
##### 2. Choose the value of the query's parameters #####
# ---- Required parameters ---- #
exchange = "krkn"
instrument_class = "spot"
pair = "btc-usd" #called "instrument" in the documentation
# ---- Optional parameters ---- #
sort = "desc"
page_size = 100
start_time= "2025-03-03T00:00:00Z"
end_time= "2025-03-05T00:00:00Z"
# ---- API key configuration ---- #
api_key = "YOUR_API_KEY"
##### 3. Get the data #####
# ---- Function to run an API call ---- #
# Get the data in a dataframe --------- #
def get_kaiko_data(api_key: str, exchange: str, pair: str, instrument_class: str, start_time: str, end_time: str, sort: str, page_size: int):
headers = {'Accept': 'application/json', 'X-Api-Key': api_key}
url = f'https://us.market-api.kaiko.io/v2/data/order_book_snapshots.v1/exchanges/{exchange}/{instrument_class}/{pair}/snapshots/slippage'
params = {
"start_time": start_time,
"end_time": end_time,
"sort": sort,
"page_size": page_size
}
try:
res = requests.get(url, headers=headers, params=params)
res.raise_for_status()
data = res.json()
if 'data' not in data:
print("No data returned.")
return pd.DataFrame()
df = pd.DataFrame(data['data'])
# Handle pagination with continuation token
while 'next_url' in data:
next_url = data['next_url']
if next_url is None:
break
res = requests.get(next_url, headers=headers)
res.raise_for_status()
data = res.json()
if 'data' in data:
df = pd.concat([df, pd.DataFrame(data['data'])], ignore_index=True)
return df
except requests.exceptions.RequestException as e:
print(f"API request error: {e}")
return pd.DataFrame()
# ---- Get the data ---- #
df = get_kaiko_data(api_key=api_key, exchange=exchange, pair=pair, instrument_class=instrument_class, start_time=start_time, end_time=end_time ,sort=sort, page_size=int(page_size)){
"query": {
"page_size": 10,
"exchange": "krkn",
"instrument_class": "spot",
"instrument": "btc-usd",
"interval": "1h",
"slippage": 100000,
"slippage_ref": "mid_price",
"sort": "desc",
"aggregation": "full",
"data_version": "v1",
"commodity": "order_book_snapshots",
"request_time": "2020-05-26T14:46:00.561Z"
},
"time": "2020-05-26T14:46:03.776Z",
"timestamp": 1590504363776,
"data": [
{
"poll_timestamp": 1590501600000,
"ask_slippage": "0.00032766083806437735",
"bid_slippage": "0.0002206511273162024",
"bid_volume0_1": "31.751239130434783",
"bid_volume0_2": "87.33763043478261",
"bid_volume0_3": "139.32403260869566",
"bid_volume0_4": "177.62314130434783",
"bid_volume0_5": "206.71984782608695",
"bid_volume0_6": "251.4888043478261",
"bid_volume0_7": "287.1503043478261",
"bid_volume0_8": "317.3515869565217",
"bid_volume0_9": "335.79671739130436",
"bid_volume1": "352.03117391304346",
"bid_volume1_5": "419.0988260869565",
"bid_volume2": "470.6285",
"bid_volume4": "859.7884347826086",
"bid_volume6": "1134.0595760869564",
"bid_volume8": "1134.4657173913045",
"bid_volume10": "1134.4657173913045",
"ask_volume0_1": "21.558043478260867",
"ask_volume0_2": "37.20532608695652",
"ask_volume0_3": "78.02648913043478",
"ask_volume0_4": "143.83753260869565",
"ask_volume0_5": "192.98572826086954",
"ask_volume0_6": "235.31961956521738",
"ask_volume0_7": "280.5659565217391",
"ask_volume0_8": "309.4857717391304",
"ask_volume0_9": "327.8923152173913",
"ask_volume1": "341.79707608695657",
"ask_volume1_5": "411.3568043478261",
"ask_volume2": "475.6048586956521",
"ask_volume4": "885.1007826086956",
"ask_volume6": "1263.1216413043478",
"ask_volume8": "1364.2838369565218",
"ask_volume10": "1364.2838369565218",
"mid_price": "8830.427717391303",
"spread": "1.175"
}
/* ... */
],
"result": "success",
"access": {
"access_range": {
"start_timestamp": null,
"end_timestamp": null
},
"data_range": {
"start_timestamp": null,
"end_timestamp": null
}
}
}https://us.market-api.kaiko.io/v2/data/order_book_snapshots.v1/exchanges/{exchange}/{instrument_class}/{instrument}/ob_aggregations/fullcurl --compressed -H 'Accept: application/json' -H 'X-Api-Key: KAIKO_API_KEY' \
'https://us.market-api.kaiko.io/v2/data/liquidity.v1/snapshots/usp3?pool_address=0x88e6a0c2ddd26feeb64f039a2c41296fcb3f5640'##### 1. Import dependencies #####
import requests
import pandas as pd
##### 2. Choose the value of the query's parameters #####
# ---- Required parameters ---- #
pool_address = "0x88e6a0c2ddd26feeb64f039a2c41296fcb3f5640"
# ---- Optional parameters ---- #
blockchain = "ethereum"
live = "false"
start_block = None
end_block = None
start_time = "2022-04-01T00:00:00.000Z"
end_time = "2022-04-01T00:02:00.000Z"
sort = "desc"
price_range = None
page_size = 100
# ---- API key configuration ---- #
api_key = "YOUR_API_KEY"
##### 3. Get the data #####
# ---- Function to run an API call ---- #
# Get the data in a dataframe --------- #
def get_kaiko_data(api_key: str, pool_address: str, blockchain: str, live: str,
start_block: str, end_block: str, start_time: str,
end_time: str, sort: str, price_range: str, page_size: int):
headers = {'Accept': 'application/json', 'X-Api-Key': api_key}
url = f'https://eu.market-api.kaiko.io/v2/data/liquidity.v1/snapshots/usp3'
params = {
"pool_address": pool_address,
"blockchain": blockchain,
"live": live,
"start_block": start_block,
"end_block": end_block,
"start_time": start_time,
"end_time": end_time,
"sort": sort,
"price_range": price_range,
"page_size": page_size
}
try:
res = requests.get(url, headers=headers, params=params)
res.raise_for_status()
data = res.json()
if 'data' not in data:
return pd.DataFrame()
df = pd.DataFrame(data['data'])
# Handle pagination with continuation token
while 'next_url' in data:
next_url = data['next_url']
if next_url is None:
break
res = requests.get(next_url, headers=headers)
res.raise_for_status()
data = res.json()
if 'data' in data:
df = pd.concat([df, pd.DataFrame(data['data'])], ignore_index=True)
return df
except requests.exceptions.RequestException as e:
return pd.DataFrame()
# ---- Get the data ---- #
df = get_kaiko_data(api_key=api_key, pool_address=pool_address, blockchain=blockchain,
live=live, start_block=start_block, end_block=end_block,
start_time=start_time, end_time=end_time, sort=sort,
price_range=price_range, page_size=int(page_size))https://eu.market-api.kaiko.io/v2/data/liquidity.v1/snapshots/usp3{
"query": {
"blockchain": "ethereum",
"protocol": "usp3",
"pool_address": "0x88e6a0c2ddd26feeb64f039a2c41296fcb3f5640",
"start_block": "*",
"end_block": "*",
"start_time": "*",
"end_time": "*",
"sort": "descending",
"page_size": "10",
"live": "false",
"price_range": "0.1"
},
"time": "2024-09-27T14:03:53.973Z",
"timestamp": 1727445833,
"data": [
{
"block_number": "20842364",
"pool_name": "liquidity_pool",
"pool_address": "0x88e6a0c2ddd26feeb64f039a2c41296fcb3f5640",
"current_tick": "197507",
"current_price": 0.00037773843033961135,
"datetime": 1727444963,
"blockchain": "ethereum",
"exchange": "usp3",
"snapshots": [
{
"amount0": 0,
"amount1": 21.540770877363897,
"amount": 2335301572930716700,
"lower_tick": 196460,
"upper_tick": 196470
},
{
"amount0": 0,
"amount1": 21.58927177741234,
"amount": 2339389776616961000,
"lower_tick": 196470,
"upper_tick": 196480
},
...
]
},
...
],
"continuation_token": "xxx",
"next_url": "https://us.market-api.kaiko.io/v2/data/liquidity.v1/snapshots/usp3?continuation_token=xxx"
}
curl --compressed -H 'Accept: application/json' -H 'X-Api-Key: <client-api-key>' \
'https://us.market-api.kaiko.io/v2/data/trades.v1/robust_pair_price/btc/eth?interval=1m&extrapolate_missing_values=true&start_time=2023-05-03T00:01:00.000Z&end_time=2023-05-04T00:00:00.000Z'##### 1. Import dependencies #####
import requests
import pandas as pd
##### 2. Choose the value of the query's parameters #####
# ---- Required parameters ---- #
base_asset = "btc"
quote_asset = "usd"
interval = "1h"
# ---- Optional parameters ---- #
sort = "desc"
page_size = 4
start_time= "2023-01-01T00:00:00Z"
end_time= "2023-01-01T23:59:59Z"
include_exchanges = None
exclude_exchanges = None
extrapolate_missing_values = None
# ---- API key configuration ---- #
api_key = "YOUR_API_KEY"
##### 3. Get the data #####
# ---- Function to run an API call ---- #
# Get the data in a dataframe --------- #
def get_kaiko_data(api_key: str, base_asset: str, quote_asset: str, interval: str, start_time: str, end_time: str, sort: str, page_size: int, include_exchanges: list = None, exclude_exchanges: list = None, extrapolate_missing_values: bool = None):
headers = {'Accept': 'application/json', 'X-Api-Key': api_key}
url = f'https://us.market-api.kaiko.io/v2/data/trades.v1/robust_pair_price/{base_asset}/{quote_asset}'
params = {
"start_time": start_time,
"end_time": end_time,
"sort": sort,
"page_size": page_size,
"interval": interval,
"include_exchanges": include_exchanges,
"exclude_exchanges": exclude_exchanges,
"extrapolate_missing_values": extrapolate_missing_values
}
try:
res = requests.get(url, headers=headers, params=params)
res.raise_for_status()
data = res.json()
if 'data' not in data:
print("No data returned.")
return pd.DataFrame()
df = pd.DataFrame(data['data'])
# Handle pagination with continuation token
while 'next_url' in data:
next_url = data['next_url']
if next_url is None:
break
res = requests.get(next_url, headers=headers)
res.raise_for_status()
data = res.json()
if 'data' in data:
df = pd.concat([df, pd.DataFrame(data['data'])], ignore_index=True)
return df
except requests.exceptions.RequestException as e:
print(f"API request error: {e}")
return pd.DataFrame()
# ---- Get the data ---- #
df = get_kaiko_data(api_key=api_key, base_asset=base_asset, quote_asset=quote_asset, interval=interval, start_time=start_time, end_time=end_time, sort=sort, page_size=page_size, include_exchanges=include_exchanges, exclude_exchanges=exclude_exchanges, extrapolate_missing_values=extrapolate_missing_values)
print (df)https://<eu|us>.market-api.kaiko.io/v2/data/trades.v1/robust_pair_price/{base_asset}/{quote_asset}{
"query": {
"start_time": "2023-05-03T23:50:00Z",
"end_time": "2023-05-04T00:00:00Z",
"base_asset": "btc",
"quote_asset": "eth",
"interval": "1m",
"sort": "desc",
"sources": false,
"page_size": 10,
"include_exchanges": [],
"exclude_exchanges": [],
"request_time": "2024-07-11T07:39:11.34695219Z",
"data_version": "v1",
"commodity": "trades",
"extrapolate_missing_values": true,
"instruments": [
"bbsp:spot:eth-btc",
"bfly:spot:eth-btc",
"bfnx:spot:eth-btc",
"bgon:spot:eth-btc",
"binc:spot:eth-btc",
"bnus:spot:eth-btc",
"bull:spot:eth-btc",
"cbse:spot:eth-btc",
"cnex:spot:eth-btc",
"kcon:spot:eth-btc",
"krkn:spot:eth-btc",
"lmax:spot:eth-btc",
"okex:spot:eth-btc",
"stmp:spot:eth-btc",
"yobt:spot:eth-btc"
]
},
"time": "2024-07-11T07:39:11.430101692Z",
"timestamp": 1720683551,
"data": [
{
"timestamp": 1683158340000,
"price": "15.236109727862226",
"volume": "10.661977267122458",
"count": 263,
"extrapolate_missing_values": false
},
{
"timestamp": 1683158280000,
"price": "15.226897227981592",
"volume": "26.42011153624422",
"count": 184,
"extrapolate_missing_values": false
},
/*...*/
],
"result": "success",
"continuation_token": "V7Dxo9XotwyC1qQtT6Dkaq3fhY8jFqzmgjwkALFWdZQ4JHWoUQFrDaTw8Zc4yCY4Cf863uPBY4phumdqcjoL4imnx5amnLJCZP3rr7dDBw2EC33kpYtsRPsmx1sVW2tfp5pUh72fP9gYrhHzzQpGAz5PKFFwiTuHT921xT1ajG8EV9aRibXxs69PLGwnfH6WD5iw4SAc58c7ZF8PafYgb34APyYC1",
"next_url": "https://us.market-api.kaiko.io/v2/data/trades.v1/robust_pair_price/btc/eth?continuation_token=V7Dxo9XotwyC1qQtT6Dkaq3fhY8jFqzmgjwkALFWdZQ4JHWoUQFrDaTw8Zc4yCY4Cf863uPBY4phumdqcjoL4imnx5amnLJCZP3rr7dDBw2EC33kpYtsRPsmx1sVW2tfp5pUh72fP9gYrhHzzQpGAz5PKFFwiTuHT921xT1ajG8EV9aRibXxs69PLGwnfH6WD5iw4SAc58c7ZF8PafYgb34APyYC1",
"access": {
"access_range": {
"start_timestamp": 1262995200000,
"end_timestamp": 2186006399000
},
"data_range": {
"start_timestamp": null,
"end_timestamp": null
}
}
}curl --compressed -H 'Accept: application/json' -H 'X-Api-Key: <client-api-key>' \
'https://us.market-api.kaiko.io/v2/data/trades.v2/spot_exchange_rate/dash/usd?interval=1m&extrapolate_missing_values=true&start_time=2023-05-03T00:01:00.000Z&end_time=2023-05-04T00:00:00.000Z'##### 1. Import dependencies #####
import requests
import pandas as pd
##### 2. Choose the value of the query's parameters #####
# ---- Required parameters ---- #
base_asset = "btc"
quote_asset = "usd"
# ---- Optional parameters ---- #
interval = "1h"
sort = "desc"
page_size = 4
start_time= "2023-01-01T00:00:00Z"
end_time= "2023-01-01T23:59:59Z"
include_exchanges = None
exclude_exchanges = None
extrapolate_missing_values = None
sources = None
# ---- API key configuration ---- #
api_key = "YOUR_API_KEY"
##### 3. Get the data #####
# ---- Function to run an API call ---- #
# Get the data in a dataframe --------- #
def get_kaiko_data(api_key: str, base_asset: str, quote_asset: str, start_time: str, end_time: str, interval: str, sort: str, page_size: int, include_exchanges: list = None, exclude_exchanges: list = None, extrapolate_missing_values: bool = None, sources: bool = None):
headers = {'Accept': 'application/json', 'X-Api-Key': api_key}
url = f'https://us.market-api.kaiko.io/v2/data/trades.v2/spot_exchange_rate/{base_asset}/{quote_asset}'
params = {
"start_time": start_time,
"end_time": end_time,
"sort": sort,
"page_size": page_size,
"interval": interval,
"include_exchanges": include_exchanges,
"exclude_exchanges": exclude_exchanges,
"extrapolate_missing_values": extrapolate_missing_values,
"sources": sources
}
try:
res = requests.get(url, headers=headers, params=params)
res.raise_for_status()
data = res.json()
if 'data' not in data:
print("No data returned.")
return pd.DataFrame()
df = pd.DataFrame(data['data'])
# Handle pagination with continuation token
while 'next_url' in data:
next_url = data['next_url']
if next_url is None:
break
res = requests.get(next_url, headers=headers)
res.raise_for_status()
data = res.json()
if 'data' in data:
df = pd.concat([df, pd.DataFrame(data['data'])], ignore_index=True)
return df
except requests.exceptions.RequestException as e:
print(f"API request error: {e}")
return pd.DataFrame()
# ---- Get the data ---- #
df = get_kaiko_data(api_key=api_key, base_asset=base_asset, quote_asset=quote_asset, interval=interval, start_time=start_time, end_time=end_time, sort=sort, page_size=page_size, include_exchanges=include_exchanges, exclude_exchanges=exclude_exchanges, extrapolate_missing_values=extrapolate_missing_values, sources=sources)
print (df)https://<eu|us>.market-api.kaiko.io/v2/data/trades.v2/spot_exchange_rate/{base_asset}/{quote_asset}{
"query": {
"start_time": "2023-05-03T00:01:00Z",
"end_time": "2023-05-04T00:00:00Z",
"page_size": 10,
"base_asset": "dash",
"quote_asset": "usd",
"interval": "1m",
"sort": "desc",
"sources": false,
"include_exchanges": [],
"exclude_exchanges": [],
"data_version": "v1",
"commodity": "trades",
"request_time": "2024-07-11T08:10:21.828Z",
"instruments": [
"bbsp:spot:btc-usdt",
"bfnx:spot:btc-usdt",
"bgon:spot:btc-usdt",
"binc:spot:btc-usdt",
"bnus:spot:btc-usdt",
"bull:spot:btc-usdt",
"cbse:spot:btc-usdt",
"cnex:spot:btc-usdt",
"gmni:spot:btc-usdt",
"kcon:spot:btc-usdt",
"krkn:spot:btc-usdt",
"okex:spot:btc-usdt",
"stmp:spot:btc-usdt",
"bfnx:spot:dash-btc",
"binc:spot:dash-btc",
"cbse:spot:dash-btc",
"cnex:spot:dash-btc",
"yobt:spot:dash-btc",
"bfnx:spot:usdt-usd",
"bnus:spot:usdt-usd",
"cbse:spot:usdt-usd",
"gmni:spot:usdt-usd",
"krkn:spot:usdt-usd",
"stmp:spot:usdt-usd"
],
"start_timestamp": 1683157800000,
"end_timestamp": 1683158400000,
"extrapolate_missing_values": true
},
"time": "2024-07-11T08:10:21.891Z",
"timestamp": 1720685421891,
"data": [
{
"timestamp": 1683158340000,
"price": "49.263380298334226",
"extrapolated": false
},
{
"timestamp": 1683158280000,
"price": "49.24160302106242",
"extrapolated": false
},
/*...*/
],
"result": "success",
"continuation_token": "AV2cWacBUPR8PvJTwoHZtPBUSEuqNYcv2iNgL96oZpT6MqqGc6ajQo7XM66wySCwViwNjs9C8Gu1xS2rRwGMrCT6rCRxFDCFnnKusyGFo34HkuY7Em7KqgpSzNADLhciV7w5UPeJrvm6cDgTnsaKVUgLMpj2ZioT",
"next_url": "https://us.market-api.kaiko.io/v2/data/trades.v2/spot_exchange_rate/dash/usd?continuation_token=AV2cWacBUPR8PvJTwoHZtPBUSEuqNYcv2iNgL96oZpT6MqqGc6ajQo7XM66wySCwViwNjs9C8Gu1xS2rRwGMrCT6rCRxFDCFnnKusyGFo34HkuY7Em7KqgpSzNADLhciV7w5UPeJrvm6cDgTnsaKVUgLMpj2ZioT",
"access": {
"access_range": {
"start_timestamp": 1262995200000,
"end_timestamp": 2186006399000
},
"data_range": {
"start_timestamp": null,
"end_timestamp": null
}
}
}curl --compressed -H 'Accept: application/json' -H 'X-Api-Key: <client-api-key>' \
'https://us.market-api.kaiko.io/v2/data/analytics.v2/exchange_metrics?exchange=cbse&sort=desc&sources=true&start_time=2023-11-29T14:00:00.0000000Z&end_time=2023-11-29T15:00:00.0000000Z&interval=1h&page_size=100'import http.client
import json
# Enter your Kaiko API Key
api_key = "KAIKO_API_KEY"
api_host = "us.market-api.kaiko.io"
api_base_endpoint = "/v2/data/analytics.v2/exchange_metrics"
# Start of mandatory parameter configuration
mandatory_params = {
"exchange": "cbse",
"start_time": "2024-08-27T13:13:53.441Z",
"end_time" : "2024-08-27T18:27:53.441Z",
"interval" : "1h",
}
# End of mandatory parameter configuration
# Start of optional parameter configuration
optional_params = {
"sources": "false",
}
# End of optional parameter configuration
conn = http.client.HTTPSConnection(api_host)
headers = {
"X-Api-Key": api_key,
"Accept": "application/json"
}
all_params = {**mandatory_params, **optional_params}
url_params = []
for param, value in all_params.items():
url_params.append(f"{param}={value}")
url_params = '&'.join(url_params)
endpoint_with_params = f"{api_base_endpoint}?{url_params}"
# Pagination for next pages
all_data = []
next_url = endpoint_with_params
while next_url:
conn.request("GET", next_url, headers=headers)
response = conn.getresponse()
data = json.loads(response.read().decode("utf-8"))
all_data.extend(data.get("data", []))
print(f"Fetched {len(data.get('data', []))} datapoints. Total: {len(all_data)}")
next_url = data.get("next_url", "").replace("https://us.market-api.kaiko.io", "")
if not next_url:
break
conn.close()
print(f" datapoints fetched: {(all_data)}"){
"data": [
{
"timestamp": "2023-11-29T14:00:00.000Z",
"total_volume_usd": 139803179.89191553,
"total_trade_count": 121748,
"nb_listed_assets": 235,
"nb_listed_pairs": 379,
"assets_volumes": [
{
"asset_code": "btc",
"asset_trade_count": 22772,
"asset_total_volume_usd": 61612344.01769975,
"asset_price_usd": 37994.62623807689,
"asset_contribution": 0.4407077440250888,
"pairs_volumes": [
{
"pair_code": "btc-usd",
"pair_trade_count": 19193,
"pair_volume_usd": 57484171.99063697,
"pair_contribution": 0.9329976469345679
},
{
"pair_code": "btc-eur",
"pair_trade_count": 1686,
"pair_volume_usd": 1722929.4947314486,
"pair_contribution": 0.027964030945430225
},
{
"pair_code": "btc-usdt",
"pair_trade_count": 807,
"pair_volume_usd": 1590807.5262940996,
"pair_contribution": 0.02581962351305931
},
{
"pair_code": "btc-gbp",
"pair_trade_count": 1086,
"pair_volume_usd": 814435.0060372388,
"pair_contribution": 0.013218698606942646
}
]
},
/* ... */
]
},
/* ... */
]
}https://us.market-api.kaiko.io/v2/data/analytics.v2/exchange_metricshttps://{region}.market-api.kaiko.io/v3/data/trades.v1/exchanges/{exchange}/{instrument_class}/{instrument}/tradescurl --compressed -H 'Accept: application/json' -H 'X-Api-Key: <client-api-key>' \
'https://us.market-api.kaiko.io/v3/data/trades.v1/exchanges/bfnx/spot/btc-usd/trades'##### 1. Import dependencies #####
import requests
import pandas as pd
##### 2. Choose the value of the query's parameters #####
# ---- Required parameters ---- #
exchange = "cbse"
instrument_class = "spot"
pair = "btc-usd" #called "instrument" in the documentation
# ---- Optional parameters ---- #
sort = "desc"
page_size = "100"
start_time= "2023-01-01T00:00:00Z"
end_time= "2023-01-01T00:03:00Z"
# ---- API key configuration ---- #
api_key = "YOUR_API_KEY"
##### 3. Get the data #####
# ---- Function to run an API call ---- #
# Get the data in a dataframe --------- #
def get_kaiko_data(api_key: str, exchange: str, pair: str, instrument_class: str, start_time: str, end_time: str, sort: str, page_size: int):
headers = {'Accept': 'application/json', 'X-Api-Key': api_key}
url = f'https://us.market-api.kaiko.io/v3/data/trades.v1/exchanges/{exchange}/{instrument_class}/{pair}/trades'
params = {
"start_time": start_time,
"end_time": end_time,
"sort": sort,
"page_size": page_size
}
try:
res = requests.get(url, headers=headers, params=params)
res.raise_for_status()
data = res.json()
if 'data' not in data:
print("No data returned.")
return pd.DataFrame()
df = pd.DataFrame(data['data'])
# Handle pagination with continuation token
while 'next_url' in data:
next_url = data['next_url']
if next_url is None:
break
res = requests.get(next_url, headers=headers)
res.raise_for_status()
data = res.json()
if 'data' in data:
df = pd.concat([df, pd.DataFrame(data['data'])], ignore_index=True)
return df
except requests.exceptions.RequestException as e:
print(f"API request error: {e}")
return pd.DataFrame()
# ---- Get the data ---- #
df = get_kaiko_data(api_key=api_key, exchange=exchange, pair=pair, instrument_class=instrument_class, start_time=start_time, end_time=end_time ,sort=sort, page_size=int(page_size)){
"query": {
"page_size": 100,
"exchange": "bfnx",
"instrument_class": "spot",
"instrument": "btc-usd",
"sort": "desc",
"data_version": "v1",
"commodity": "trades",
"request_time": "2020-11-12T16:33:20.575Z"
},
"time": "2020-11-12T16:33:20.869Z",
"timestamp": 1605198800869,
"access": {
"access_range": {
"start_timestamp": null,
"end_timestamp": null
},
"data_range": {
"start_timestamp": null,
"end_timestamp": null
}
},
"data": [
{
"timestamp": 1605198775855,
"trade_id": "522419198",
"price": "16026",
"amount": "0.025",
"taker_side_sell": true
},
{
"timestamp": 1605198775031,
"trade_id": "522419197",
"price": "16026",
"amount": "0.01",
"taker_side_sell": true
},
/* ... */
],
"result": "success",
"continuation_token": "rbd28vrmb1cwaxfykuJBKAABhNi1Bfv1EY55P3QPSnYnm8VuX1LqLhA2d3yVfYgMKtfBYxJg7sHrkTfkQGysW23Lm9Lp9rsVpVk2Esmgz9VQZvNE4xWN8hh3LgLrCa7ty4B3YGCwtH",
"next_url": "https://us.market-api.kaiko.io/v3/data/trades.v1/exchanges/bfnx/spot/btc-usd/trades?continuation_token=rbd28vrmb1cwaxfykuJBKAABhNi1Bfv1EY55P3QPSnYnm8VuX1LqLhA2d3yVfYgMKtfBYxJg7sHrkTfkQGysW23Lm9Lp9rsVpVk2Esmgz9VQZvNE4xWN8hh3LgLrCa7ty4B3YGCwtH"
}{
"query": {
"page_size": 100,
"exchange": "bfnx",
"instrument_class": "spot",
"instrument": "btc-usd",
"sort": "desc",
"data_version": "v1",
"commodity": "trades",
"request_time": "2020-11-12T16:33:20.575Z"
},
"time": "2020-11-12T16:33:20.869Z",
"timestamp": 1605198800869,
"access": {
"access_range": {
"start_timestamp": null,
"end_timestamp": null
},
"data_range": {
"start_timestamp": null,
"end_timestamp": null
}
},
"data": [
{
"timestamp": 1605198775855,
"trade_id": "522419198",
"price": "16026",
"amount": "0.025",
"taker_side_sell": true
},
{
"timestamp": 1605198775031,
"trade_id": "522419197",
"price": "16026",
"amount": "0.01",
"taker_side_sell": true
},
/* ... */
],
"result": "success",
[...]
